SystemOrganization addCategory: #'Tweak-CoreTests-Widgets'!
SystemOrganization addCategory: #'Tweak-CoreTests-Tools'!
SystemOrganization addCategory: #'Tweak-CoreTests-Kernel'!

CObject subclass: #CEventTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CEventTestClass methodsFor: 'intialize' stamp: 'ar 5/7/2005 17:58'!
initialize
	super initialize.
	testField := CPlayer new.
	self signal: #testSignal.
! !

!CEventTestClass methodsFor: 'events' stamp: 'ar 5/7/2005 16:58'!
onTestFieldChanged
	<on: testFieldChanged>
	self class signal: #testFieldChangeReceived with: self.! !

!CEventTestClass methodsFor: 'events' stamp: 'ar 5/7/2005 17:57'!
onTestFieldValueChanged
	<on: valueChanged in: testField>
	self signal: #testFieldValueChanged.! !

!CEventTestClass methodsFor: 'events' stamp: 'ar 5/7/2005 16:57'!
onTestSignal
	<on: testSignal>
	self class signal: #testSignalReceived with: self.! !

!CEventTestClass methodsFor: 'events' stamp: 'ar 5/7/2005 16:52'!
onTestTrigger
	<on: testTrigger> 
	self signal: #testTriggerReceived.! !

!CEventTestClass methodsFor: 'events' stamp: 'ar 5/7/2005 18:32'!
onVirtualFieldSignal
	<on: valueChanged in: virtualField>

! !

!CEventTestClass methodsFor: 'accessing' stamp: 'ar 5/7/2005 16:48'!
testField
	"Answer the testField of the receiver"
	<bewareOf: #testFieldChanged>
	^self propertyValueAt: #testField! !

!CEventTestClass methodsFor: 'accessing' stamp: 'ar 5/7/2005 16:48'!
testField: aValue
	"Modify the receiver's testField"
	^self propertyValueAt: #testField put: aValue with: #testFieldChanged! !

!CEventTestClass methodsFor: 'accessing' stamp: 'ar 5/7/2005 18:34'!
virtualField
	"Answer the virtualField of the receiver"
	self class signal: #virtualFieldFetched.
	^testField! !

CEventTestClass subclass: #CEventTestSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CEventTestSubclass methodsFor: 'intialize' stamp: 'ar 5/7/2005 18:28'!
initialize
	super initialize.
	self pauseScript: #onTestFieldValueChanged.! !

!CEventTestSubclass methodsFor: 'events' stamp: 'ar 5/7/2005 16:52'!
onTestTrigger
	"Override without changing trigger"
	super onTestTrigger.! !

CEventTestClass subclass: #CEventTestSubclassWithOverride
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CEventTestSubclassWithOverride methodsFor: 'intialize' stamp: 'ar 5/7/2005 18:28'!
initialize
	super initialize.
	self stopScript: #onTestFieldValueChanged.! !

!CEventTestSubclassWithOverride methodsFor: 'events' stamp: 'ar 5/7/2005 16:53'!
onTestTrigger
	"Override with changing trigger"
	<on: testTriggerOverride>
	super onTestTrigger.! !

TestSuite subclass: #CTestSuite
	instanceVariableNames: 'island project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CTestSuite methodsFor: 'running' stamp: 'ar 12/9/2009 22:45'!
run: aResult
	| script |
	island := CProjectIsland new.
	island scheduler: (island new: ScriptScheduler).
	island project: (project := island new: CProject2 defaultProject).
	project newProjectWith: (island new: CTestWorld).
	project canvas: (CTransformCanvas on: Display).
	project startScript: #run.
	self tests do: [:each| 
		self sunitChanged: each.
		script := (island shallowCopy: each) startScript: #run: withArguments: {aResult}.
		[script isDone] whileFalse:[island scheduler run].
	].

	island project signal: #shutDownProject with: true.
	island scheduler run.
	island scheduler shutDown.

	Display restore.! !

CPlayer subclass: #CTestWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CTestWorld methodsFor: 'initialize' stamp: 'ar 5/30/2005 14:50'!
initialize
	super initialize.
	color := Color gray.
	self extent: 640@480.! !

TestCase subclass: #CTestCase
	instanceVariableNames: 'saveWorld world hand myScripts parentProcess debugging'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CTestCase commentStamp: 'ar 10/27/2004 17:10' prior: 0!
Common superclass providing some generic utilities.!

CTestCase subclass: #CBugFixTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CBugFixTests commentStamp: '<historical>' prior: 0!
Various tests to make sure certain problems are addressed.!

!CBugFixTests methodsFor: 'tests' stamp: 'ar 6/22/2005 23:33'!
testColorFormDeepCopiesColors
	"This will screw up islands if we ever need to copy a default form"
	| colorForm colors |
	colorForm := ColorForm extent: 10@10 depth: 1.
	colors := colorForm colors.
	self deny: (colorForm deepCopy colors == colors).

	colorForm := ColorForm extent: 10@10 depth: 2.
	colors := colorForm colors.
	self deny: (colorForm deepCopy colors == colors).

	colorForm := ColorForm extent: 10@10 depth: 4.
	colors := colorForm colors.
	self deny: (colorForm deepCopy colors == colors).

	colorForm := ColorForm extent: 10@10 depth: 8.
	colors := colorForm colors.
	self deny: (colorForm deepCopy colors == colors).
! !

CTestCase subclass: #CObjectTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CObjectTests commentStamp: '<historical>' prior: 0!
Generic superclass for tests run in CObjects!

CObjectTests subclass: #CEventTests
	instanceVariableNames: 'class1 class2 instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CEventTests commentStamp: '<historical>' prior: 0!
Tests for method trigger behavior.!

!CEventTests methodsFor: 'tests-compiling' stamp: 'ar 5/7/2005 23:43'!
tearDown
	instance ifNotNil:[instance destroy]. "before removing classes"
	class1 ifNotNil:[class1 removeFromSystem: false].
	class2 ifNotNil:[class2 removeFromSystem: false].! !

!CEventTests methodsFor: 'tests-compiling' stamp: 'ar 5/7/2005 16:43'!
testChangingSuperclass
	"make sure that changing the superclass doesn't create extra triggers"
	class1 := CPlayer 
		subclass: #CEventTestSubclass1 
		instanceVariableNames:''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	class1 compile: 'testTrigger <on: testTrigger> self signal: #testWasTriggered'.
	self assert: class1 methodTriggers size = 1.
	self assert: class1 methodTriggers first eventName == #testTrigger.

	class2 := CPlayer 
		subclass: #CEventTestSubclass2
		instanceVariableNames:''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	class2 compile: 'testTrigger <on: testTrigger> self signal: #testWasTriggered'.

	self assert: class2 methodTriggers size = 1.
	self assert: class2 methodTriggers first eventName == #testTrigger.

	class2 := class1
		subclass: #CEventTestSubclass2
		instanceVariableNames:''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	self assert: class2 methodTriggers size = 1.
	self assert: class2 methodTriggers first eventName == #testTrigger.
! !

!CEventTests methodsFor: 'tests-error handling' stamp: 'ar 5/10/2005 14:29'!
testErrorHandler
	| player caught count error |
	player := CPlayer new.
	count := 0.
	player startScript:[:ex| caught := ex. count := count + 1] when:{player. #error}.
	[3 / 0] on: Error do:[:ex| error := ex. player handleError: ex ifNone:[]].
	self assert: (count = 1). "signaled synchronously"
	self assert: error == caught. "we got the right event"! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:43'!
testInitializeFieldChange
	"Test that assigning to a regular field generates a fieldChanged event, e.g., that the following works properly:
		initialize
			testField := CPlayer new.
		onTestFieldChanged
			<on: testFieldChanged>
	"
	| count |
	count := 0.
	self startScript:[:who| who == instance ifTrue:[count := count + 1]]
		when:{CEventTestClass. #testFieldChangeReceived}.
	instance := CEventTestClass new.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:43'!
testInitializeFieldChangeSync
	"Test that assigning to a regular field generates a fieldChanged event, e.g., that the following works properly:
		initialize
			testField := CPlayer new.
		onTestFieldChanged
			<on: testFieldChanged>
	"
	| count |
	count := 0.
	self runScript:[:who| who == instance ifTrue:[count := count + 1]]
		when:{CEventTestClass. #testFieldChangeReceived}.
	instance := CEventTestClass new.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:57'!
testInitializeFieldUpdate
	"Test that after assigning to a regular field in #initialize method triggers update themselves properly, e.g., that the following combination works properly:
		initialize
			testField := CPlayer.
		onTestFieldValueChanged
			<on: valueChanged in: testField>
	"
	| count |
	instance := CEventTestClass new.
	count := 0.
	self startScript:[count := count +1] when:{instance. #testFieldValueChanged}.
	self waitTick.
	self assert: count = 0.
	instance testField value: 42.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:57'!
testInitializeFieldUpdateSync
	"Test that after assigning to a regular field in #initialize method triggers update themselves properly, e.g., that the following combination works properly:
		initialize
			testField := CPlayer.
		onTestFieldValueChanged
			<on: valueChanged in: testField>
	"
	| count |
	instance := CEventTestClass new.
	count := 0.
	self runScript:[count := count +1] when:{instance. #testFieldValueChanged}.
	self waitTick.
	self assert: count = 0.
	instance testField value: 42.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:57'!
testInitializeFieldValuePaused
	"Test that after assigning to a regular field in #initialize and issueing #pauseScript in a subclass initializer method triggers update themselves properly, e.g., that the following combination works properly:
		Super>>initialize
			testField := CPlayer.
		Super>>onTestFieldValueChanged
			<on: valueChanged in: testField>
		Sub>>initialize
			super initialize.
			self pauseScript: #onTestFieldValueChanged.
	"
	| count |
	instance := CEventTestSubclass new.
	count := 0.
	self startScript:[count := count +1] when:{instance. #testFieldValueChanged}.
	self waitTick.
	self assert: count = 0.
	instance testField value: 42.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:57'!
testInitializeFieldValueStopped
	"Test that after assigning to a regular field in #initialize and issueing #pauseScript in a subclass initializer method triggers update themselves properly, e.g., that the following combination works properly:
		Super>>initialize
			testField := CPlayer.
		Super>>onTestFieldValueChanged
			<on: valueChanged in: testField>
		Sub>>initialize
			super initialize.
			self stopScript: #onTestFieldValueChanged.
	"
	| count |
	instance := CEventTestSubclassWithOverride new.
	count := 0.
	self startScript:[count := count +1] when:{instance. #testFieldValueChanged}.
	self waitTick.
	self assert: count = 0.
	instance testField value: 42.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:44'!
testInitializeSignal
	"Test that signaling events directly from initialize works properly, e.g,
		initialize
			self signal: #foo.
		onFoo
			<on: foo>
	"
	| count |
	count := 0.
	self startScript:[:who| who == instance ifTrue:[count := count + 1]]
		when:{CEventTestClass. #testSignalReceived}.
	instance := CEventTestClass new.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:44'!
testInitializeSignalSync
	"Test that signaling events directly from initialize works properly, e.g,
		initialize
			self signal: #foo.
		onFoo
			<on: foo>
	"
	| count |
	count := 0.
	self runScript:[:who| who == instance ifTrue:[count := count + 1]]
		when:{CEventTestClass. #testSignalReceived}.
	instance := CEventTestClass new.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.
! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:44'!
testInitializeVirtualFieldFetched
	"Test that a method trigger association DOES force a virtual field to be fetched, so that the following works properly:
		onVirtualFieldChanged
			<on: valueChanged in: virtualField>
		virtualField
			^self computeSomethingOrOther
	"
	| count |
	count := 0.
	self startScript:[count := count +1] when:{CEventTestClass. #virtualFieldFetched}.
	instance := CEventTestClass new.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-initialize events' stamp: 'ar 5/7/2005 23:56'!
testInitializeVirtualFieldFetchedSync
	"Test that a method trigger association DOES force a virtual field to be fetched, so that the following works properly:
		onVirtualFieldChanged
			<on: valueChanged in: virtualField>
		virtualField
			^self computeSomethingOrOther
	"
	| count |
	count := 0.
	self runScript:[count := count +1] when:{CEventTestClass. #virtualFieldFetched}.
	instance := CEventTestClass new.
	self assert: count = 1.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-error handling' stamp: 'ar 5/10/2005 14:30'!
testMultipleErrorHandler
	| player count |
	player := CPlayer new.
	count := 0.
	player startScript:[:ex| count := count + 1] when:{player. #error}.
	player startScript:[:ex| count := count + 1] when:{player. #error}.
	player startScript:[:ex| count := count + 1] when:{player. #error}.
	[3 / 0] on: Error do:[:ex|player handleError: ex ifNone:[]].
	self assert: (count = 3). "signaled synchronously"! !

!CEventTests methodsFor: 'tests-error handling' stamp: 'ar 5/10/2005 14:31'!
testMultipleErrorHandlerResponse
	| player count |
	player := CPlayer new.
	count := 0.
	player startScript:[:ex| count := count + 1. ex resume: 1] when:{player. #error}.
	player startScript:[:ex| count := count + 1. ex resume: 1] when:{player. #error}.
	player startScript:[:ex| count := count + 1. ex resume: 1] when:{player. #error}.
	[3 / 0] on: Error do:[:ex|player handleError: ex ifNone:[]].
	self assert: (count = 1). "handled just once"! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:45'!
testScriptChangedPaused
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startScript: #yourself when:{obj. #testEvent}.
	self startScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj pauseScript: #yourself.
	self deny: ok.
	self waitTick.
	self assert: ok.
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:45'!
testScriptChangedPausedSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startScript: #yourself when:{obj. #testEvent}.
	self runScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj pauseScript: #yourself.
	self assert: ok.! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:46'!
testScriptChangedResume
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startScript: #yourself when:{obj. #testEvent}.
	obj pauseScript: #yourself.
	self startScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj resumeScript: #yourself.
	self deny: ok.
	self waitTick.
	self assert: ok.
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:46'!
testScriptChangedResumeSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startScript: #yourself when:{obj. #testEvent}.
	obj pauseScript: #yourself.
	self runScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj resumeScript: #yourself.
	self assert: ok.
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:46'!
testScriptChangedStart
	| obj ok |
	obj := CPlayer new.
	ok := false.
	self startScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj startScript: #yourself when:{obj. #testEvent}.
	self deny: ok.
	self waitTick.
	self assert: ok.
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:46'!
testScriptChangedStartSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	self runScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj startScript: #yourself when:{obj. #testEvent}.
	self assert: ok.! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:46'!
testScriptChangedStop
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startScript: #yourself when:{obj. #testEvent}.
	self startScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj stopScript: #yourself.
	self deny: ok.
	self waitTick.
	self assert: ok.
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 12:46'!
testScriptChangedStopSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startScript: #yourself when:{obj. #testEvent}.
	self runScript:[:selector| ok := selector == #yourself] when:{obj. #scriptStatusChanged}.
	obj stopScript: #yourself.
	self assert: ok.! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:40'!
testTickingScriptChangedPaused
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startTicking: #yourself at: 100.
	[
		self startScript:[:selector| ok := selector == #yourself] 
			when:{obj. #scriptStatusChanged}.
		obj pauseScript: #yourself.
		self deny: ok.
		self waitTick.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:45'!
testTickingScriptChangedPausedSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startTicking: #yourself at: 100.
	[
		self runScript:[:selector| ok := selector == #yourself] 
			when:{obj. #scriptStatusChanged}.
		obj pauseScript: #yourself.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:40'!
testTickingScriptChangedResume
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startTicking: #yourself at: 100.
	[
		obj pauseScript: #yourself.
		self startScript:[:selector| ok := selector == #yourself] 
			when:{obj. #scriptStatusChanged}.
		obj resumeScript: #yourself.
		self deny: ok.
		self waitTick.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:45'!
testTickingScriptChangedResumeSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startTicking: #yourself at: 100.
	[
		obj pauseScript: #yourself.
		self runScript:[:selector| ok := selector == #yourself] 
			when:{obj. #scriptStatusChanged}.
		obj resumeScript: #yourself.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:39'!
testTickingScriptChangedStart
	| obj ok |
	obj := CPlayer new.
	ok := false.
	self startScript:[:selector| ok := selector == #yourself] 
		when:{obj. #scriptStatusChanged}.
	obj startTicking: #yourself at: 100.
	[
		self deny: ok.
		self waitTick.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:46'!
testTickingScriptChangedStartSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	self runScript:[:selector| ok := selector == #yourself] 
		when:{obj. #scriptStatusChanged}.
	obj startTicking: #yourself at: 100.
	[
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:40'!
testTickingScriptChangedStopped
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startTicking: #yourself at: 100.
	[
		self startScript:[:selector| ok := selector == #yourself] 
			when:{obj. #scriptStatusChanged}.
		obj stopScript: #yourself.
		self deny: ok.
		self waitTick.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-script activation' stamp: 'ar 5/17/2005 11:46'!
testTickingScriptChangedStoppedSync
	| obj ok |
	obj := CPlayer new.
	ok := false.
	obj startTicking: #yourself at: 100.
	[
		self runScript:[:selector| ok := selector == #yourself] 
			when:{obj. #scriptStatusChanged}.
		obj stopScript: #yourself.
		self assert: ok.
	] ensure:[obj destroy].
! !

!CEventTests methodsFor: 'tests-compiling' stamp: 'ar 5/7/2005 16:44'!
testTriggerInheritance
	"make sure that changing the superclass doesn't create extra triggers"
	class1 := CPlayer 
		subclass: #CEventTestSubclass1 
		instanceVariableNames:''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	class1 compile: 'testTrigger <on: testTrigger> self signal: #testWasTriggered'.
	self assert: class1 methodTriggers size = 1.
	self assert: class1 methodTriggers first eventName == #testTrigger.

	class2 := class1
		subclass: #CEventTestSubclass2
		instanceVariableNames:''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	class2 compile: 'testTrigger <on: testTrigger> self signal: #testWasTriggered'.
	self assert: class2 methodTriggers size = 1.
	self assert: class2 methodTriggers first eventName == #testTrigger.
! !

!CEventTests methodsFor: 'tests-trigger override' stamp: 'ar 5/7/2005 23:48'!
testTriggerNormal
	"Test regular trigger behavior, e.g.,
		Superclass>>onFoo
			<on: foo>
	"
	| count |
	instance := CEventTestClass new.
	count := 0.
	instance startScript:[count := count + 1] when:{instance. #testTriggerReceived}.

	instance signal: #testTriggerOverride.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.

	instance signal: #testTrigger.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-trigger override' stamp: 'ar 5/7/2005 23:48'!
testTriggerNormalSync
	"Test regular trigger behavior, e.g.,
		Superclass>>onFoo
			<on: foo>
	"
	| count |
	instance := CEventTestClass new.
	count := 0.
	instance runScript:[count := count + 1] when:{instance. #testTriggerReceived}.

	instance signal: #testTriggerOverride.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.

	instance signal: #testTrigger.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-trigger override' stamp: 'ar 5/7/2005 23:47'!
testTriggerOveride
	"Test that an override with a trigger uses the overridden trigger, e.g.,
		Superclass>>onFoo
			<on: foo>
		Subclass>>onFoo
			<on: bar>
	"
	| count |
	instance := CEventTestSubclassWithOverride new.
	count := 0.
	instance startScript:[count := count + 1] when:{instance. #testTriggerReceived}.

	instance signal: #testTrigger.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.

	instance signal: #testTriggerOverride.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-trigger override' stamp: 'ar 5/7/2005 23:47'!
testTriggerOverideSync
	"Test that an override with a trigger uses the overridden trigger, e.g.,
		Superclass>>onFoo
			<on: foo>
		Subclass>>onFoo
			<on: bar>
	"
	| count |
	instance := CEventTestSubclassWithOverride new.
	count := 0.
	instance runScript:[count := count + 1] when:{instance. #testTriggerReceived}.

	instance signal: #testTrigger.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.

	instance signal: #testTriggerOverride.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-trigger override' stamp: 'ar 5/7/2005 23:48'!
testTriggerSubclass
	"Test that an override without a trigger uses the inherited trigger, e.g.,
		Superclass>>onFoo
			<on: foo>
		Subclass>>onFoo
			self doSomethingOrOther.
	"
	| count |
	instance := CEventTestSubclass new.
	count := 0.
	instance startScript:[count := count + 1] when:{instance. #testTriggerReceived}.

	instance signal: #testTriggerOverride.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.

	instance signal: #testTrigger.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

!CEventTests methodsFor: 'tests-trigger override' stamp: 'ar 5/7/2005 23:48'!
testTriggerSubclassSync
	"Test that an override without a trigger uses the inherited trigger, e.g.,
		Superclass>>onFoo
			<on: foo>
		Subclass>>onFoo
			self doSomethingOrOther.
	"
	| count |
	instance := CEventTestSubclass new.
	count := 0.
	instance runScript:[count := count + 1] when:{instance. #testTriggerReceived}.

	instance signal: #testTriggerOverride.
	self assert: count = 0.
	self waitTick.
	self assert: count = 0.

	instance signal: #testTrigger.
	self assert: count = 0.
	self waitTick.
	self assert: count = 1.! !

CObjectTests subclass: #CScriptTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:21'!
descriptorTest: descriptor
	| rcvr |
	rcvr := CObject new.
	rcvr startScript: descriptor.
	self deny: (rcvr findScript: descriptor) == nil.
	rcvr stopScript: descriptor.
	self assert: (rcvr findScript: descriptor) == nil.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:19'!
testBlockScript0Args
	self descriptorTest: [].
! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:19'!
testBlockScript1Args
	self descriptorTest: [:arg1].
! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:19'!
testBlockScript2Args
	self descriptorTest: [:arg1 :arg2].
! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 5/14/2005 16:38'!
testBlockScript3Args
	self descriptorTest: [:arg1 :arg2 :arg3].! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 5/14/2005 16:38'!
testBlockScript4Args
	self descriptorTest: [:arg1 :arg2 :arg3 :arg4].! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:21'!
testSymbolScript0Args
	self descriptorTest: #foo.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:21'!
testSymbolScript1Args
	self descriptorTest: #foo:.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:21'!
testSymbolScript2Args
	self descriptorTest: #foo:arg2:.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:21'!
testSymbolScript3Args
	self descriptorTest: #foo:arg2:arg3:.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:21'!
testSymbolScript4Args
	self descriptorTest: #foo:arg2:arg3:arg4:.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:22'!
testSymbolScript5Args
	self descriptorTest: #foo:arg2:arg3:arg4:arg5:.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:22'!
testSymbolScript6Args
	self descriptorTest: #foo:arg2:arg3:arg4:arg5:arg6:.! !

!CScriptTests methodsFor: 'tests' stamp: 'ar 3/29/2005 16:22'!
testSymbolScript7Args
	self descriptorTest: #foo:arg2:arg3:arg4:arg5:arg6:arg7:.! !

CTestCase subclass: #CPlayerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

CPlayerTests subclass: #CBalloonHelpTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CBalloonHelpTest commentStamp: '<historical>' prior: 0!
Test for balloon help.!

!CBalloonHelpTest methodsFor: 'tests' stamp: 'ar 6/25/2005 22:59'!
testBalloonEnter
	| button |
	button := CPushButton new.
	button balloonHelp: 'This is a sample balloon help large enough to see that this actually works.'.
	button openCenteredIn: world.
	self sendMouseEnterTo: button.
	self assert: hand balloon container == world.
	self assert: hand balloon visible.
	"Balloon help might add linebreak so only test first characters."
	self assert: (button balloonHelp beginsWith: (hand balloon label asString upTo: Character cr)).! !

!CBalloonHelpTest methodsFor: 'tests' stamp: 'ar 6/25/2005 23:00'!
testBalloonLeave
	| button |
	button := CPushButton new.
	button balloonHelp: 'This is a sample balloon help large enough to see that this actually works.'.
	button openCenteredIn: world.
	self sendMouseEnterTo: button.
	self assert: hand balloon container == world.
	self assert: hand balloon visible.
	"Balloon help might add linebreak so only test first characters."
	self assert: (button balloonHelp beginsWith: (hand balloon label asString upTo: Character cr)).
	self sendMouseLeaveTo: button.
	self assert: hand balloon == nil.
! !

!CBalloonHelpTest methodsFor: 'tests' stamp: 'ar 6/25/2005 23:00'!
testBalloonMouseDown
	| button |
	button := CPushButton new.
	button balloonHelp: 'This is a sample balloon help large enough to see that this actually works.'.
	button openCenteredIn: world.
	self sendMouseEnterTo: button.
	self assert: hand balloon container == world.
	self assert: hand balloon visible.
	"Balloon help might add linebreak so only test first characters."
	self assert: (button balloonHelp beginsWith: (hand balloon label asString upTo: Character cr)).
	self sendMouseDownTo: button.
	self assert: hand balloon == nil.
! !

CPlayerTests subclass: #CPlayerGeometryTests
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CPlayerGeometryTests methodsFor: 'tests' stamp: 'ar 4/15/2007 19:57'!
setUp
	player := CPlayer new.
	player extent: 100@200.
	player angle: 180.! !

!CPlayerGeometryTests methodsFor: 'tests' stamp: 'ar 5/6/2005 20:13'!
testPlayerBounds
	self assert: player bounds origin rounded = (-50@50).
	self assert: player bounds corner rounded = (150@150).! !

!CPlayerGeometryTests methodsFor: 'tests' stamp: 'ar 6/25/2005 22:44'!
testPlayerExtent
	self assert: (player width = 100).
	self assert: (player height = 200).
	self assert: (player extent = (100@200)).! !

!CPlayerGeometryTests methodsFor: 'tests' stamp: 'ar 5/6/2005 20:12'!
testPlayerLeftRight
	| expected actual |
	#(left right top bottom origin corner center topLeft topRight bottomLeft bottomRight) do:[:prop|
		expected := player bounds perform: prop.
		actual := player perform: prop.
		self assert: (expected = actual).
	].! !

CPlayerTests subclass: #CSimplePlayerTests
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Kernel'!

!CSimplePlayerTests commentStamp: '<historical>' prior: 0!
Various bare player tests.!

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/4/2005 21:22'!
testAddBeforeBack
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x add: c before: a.
	self should: (x elements indexOf: c) < (x elements indexOf: a).
	self should: (x elements indexOf: c) < (x elements indexOf: b).
	self should: (x elements indexOf: a) < (x elements indexOf: b).! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/4/2005 21:22'!
testAddBeforeFwd
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x add: a before: c.
	self should: (x elements indexOf: b) < (x elements indexOf: a).
	self should: (x elements indexOf: b) < (x elements indexOf: c).
	self should: (x elements indexOf: a) < (x elements indexOf: c).! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/7/2005 18:26'!
testAddFirstA
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x addFirst: a.
	self should: (x elements indexOf: a) < (x elements indexOf: b).
	self should: (x elements indexOf: a) < (x elements indexOf: c).
	self should: (x elements indexOf: b) < (x elements indexOf: c).! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/7/2005 18:27'!
testAddFirstB
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x addFirst: b.
	self should: (x elements indexOf: b) < (x elements indexOf: a).
	self should: (x elements indexOf: b) < (x elements indexOf: c).
	self should: (x elements indexOf: a) < (x elements indexOf: c).! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/7/2005 18:27'!
testAddFirstC
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x addFirst: c.
	self should: (x elements indexOf: c) < (x elements indexOf: a).
	self should: (x elements indexOf: c) < (x elements indexOf: b).
	self should: (x elements indexOf: a) < (x elements indexOf: b).! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/7/2005 18:25'!
testAddLastA
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x addLast: a.
	self should: (x elements indexOf: b) < (x elements indexOf: a).
	self should: (x elements indexOf: b) < (x elements indexOf: c).
	self should: (x elements indexOf: c) < (x elements indexOf: a).! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/7/2005 18:26'!
testAddLastB
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x addLast: b.
	self should: (x elements indexOf: a) < (x elements indexOf: c).
	self should: (x elements indexOf: a) < (x elements indexOf: b).
	self should: (x elements indexOf: c) < (x elements indexOf: b).
! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 2/7/2005 18:26'!
testAddLastC
	| a b c x |
	a := CPlayer named: 'A'.
	b := CPlayer named: 'B'.
	c := CPlayer named: 'C'.
	x := CPlayer new.
	x addAll: {a. b. c}.
	x addLast: c.
	self should: (x elements indexOf: a) < (x elements indexOf: b).
	self should: (x elements indexOf: a) < (x elements indexOf: c).
	self should: (x elements indexOf: b) < (x elements indexOf: c).
! !

!CSimplePlayerTests methodsFor: 'color and border' stamp: 'ar 4/29/2005 00:07'!
testBorderDefaults
	| pp |
	pp := CPlayer new.
	self assert: (pp borderStyle == #none).
	self assert: (pp borderWidth = 0).
	self assert: (pp borderColor = Color transparent).

	pp borderStyle: #none.
	self assert: (pp borderStyle == #none).
	self assert: (pp borderWidth = 0).
	self assert: (pp borderColor = Color transparent).
! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 4/21/2005 22:18'!
testChangeEventListOrder
	| obj prevValue nextValue args |
	obj := CValuePlayer new.
	obj startScript:[:new :old :event|
		prevValue := old.
		nextValue := new.
		args := Array streamContents:[:s|
			event withDroppedEventsDo:[:evt| s nextPut: evt arguments].
		].
	] when:{obj. #valueChanged}.
	obj value: 0.
	self waitTick.
	self assert: (prevValue = nil).
	self assert: (nextValue = 0).
	self assert: (args = #((0 nil))).

	obj value: 1; value: 2; value: 3.
	self waitTick.
	self assert: (prevValue = 0).
	self assert: (nextValue = 3).
	self assert: (args = #((1 0) (2 1) (3 2))).
! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 4/21/2005 22:10'!
testChangeEventOrder
	| obj prevValue nextValue |
	obj := CValuePlayer new.
	obj startScript:[:new :old|
		prevValue := old.
		nextValue := new.
	] when:{obj. #valueChanged}.
	obj value: 0.
	self waitTick.
	self assert: (prevValue = nil).
	self assert: (nextValue = 0).

	obj value: 1; value: 2; value: 3.
	self waitTick.
	self assert: (prevValue = 0).
	self assert: (nextValue = 3).
! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 6/25/2005 22:56'!
testExtentWithScale
	player := CPlayer new.
	player scale: 0.5.
	player bounds: (player origin extent: 200@200).
	self assert: player extent = (400.0@400.0).
	player := CPlayer new.
	player scale: 2.0.
	player bounds: (player origin extent: 200@200).
	self assert: player extent = (100.0@100.0).
! !

!CSimplePlayerTests methodsFor: 'class reshape' stamp: 'ar 4/28/2005 19:54'!
testFieldToVar
	"Test that reshaping a field to an iVar preserves the value"
	| aClass instance |
	Utilities authorInitialsPerSe isEmptyOrNil ifTrue:[Utilities setAuthorInitials: 'test'].
	self deny: (Smalltalk includesKey: #CSimplePlayerTestsClassForTestFieldAndVar).
	aClass := CObject subclass: #CSimplePlayerTestsClassForTestFieldAndVar
		instanceVariableNames: 'testValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	[
		instance := aClass new.
		instance testValue: 42.
		self assert: (instance testValue = 42).
		aClass defineIVarField: (aClass fieldNamed: #testValue).

		self deny: (aClass fieldNamed: #testValue) isRegularField.
		self assert: (aClass fieldNamed: #testValue) isInstanceVariable.
		self assert: (aClass instVarNames includes: 'testValue').
		self assert: (instance testValue = 42).

	] ensure:[
		aClass removeFromSystem.
		Utilities authorInitialsPerSe = 'test' ifTrue:[Utilities setAuthorInitials: ''].
	].
! !

!CSimplePlayerTests methodsFor: 'color and border' stamp: 'ar 4/29/2005 00:00'!
testFillDefaults
	| pp |
	pp := CPlayer new.
	self assert: (pp fillStyle == #none).
	self assert: (pp fillAlpha = 0.0).
	self assert: (pp color = Color transparent).

	pp fillStyle: #none.
	self assert: (pp fillStyle == #none).
	self assert: (pp fillAlpha = 0.0).
	self assert: (pp color = Color transparent).
! !

!CSimplePlayerTests methodsFor: 'color and border' stamp: 'ar 4/29/2005 00:02'!
testFillRecursionBug
	| pp |
	pp := CPlayer new.
	pp fillStyle.
	pp fillAlpha: 0.5 .
	pp fillStyle: #none.

	self assert: (pp fillStyle == #none).
	self assert: (pp fillAlpha = 0.0).
	self assert: (pp color = Color transparent).
! !

!CSimplePlayerTests methodsFor: 'class reshape' stamp: 'ar 4/28/2005 19:54'!
testMultiFieldToVar
	"Test that reshaping a field to an iVar preserves the value"
	| aClass instance defA defB |
	Utilities authorInitialsPerSe isEmptyOrNil ifTrue:[Utilities setAuthorInitials: 'test'].
	self deny: (Smalltalk includesKey: #CSimplePlayerTestsClassForTestFieldAndVar).
	aClass := CObject subclass: #CSimplePlayerTestsClassForTestFieldAndVar
		instanceVariableNames: 'var1 var2 var3 var4'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	[
		instance := aClass new.
		instance var1: 1; var2: 2; var3: 3; var4: 4.
		self assert: (instance var1 = 1).
		self assert: (instance var2 = 2).
		self assert: (instance var3 = 3).
		self assert: (instance var4 = 4).

		"Change var2 and var4 to iVars"
		aClass defineIVarField: (aClass fieldNamed: #var2).
		aClass defineIVarField: (aClass fieldNamed: #var4).

		self assert: (aClass fieldNamed: #var1) isRegularField.
		self assert: (aClass fieldNamed: #var2) isInstanceVariable.
		self assert: (aClass fieldNamed: #var3) isRegularField.
		self assert: (aClass fieldNamed: #var4) isInstanceVariable.

		self assert: (instance var1 = 1).
		self assert: (instance var2 = 2).
		self assert: (instance var3 = 3).
		self assert: (instance var4 = 4).

		"Remember definition"
		defA := String streamContents:[:s| aClass fileOutOn: s].

		"Change var1 and var3 to iVars var2 and var4 to fields"
		aClass defineIVarField: (aClass fieldNamed: #var1).
		aClass defineRegularField: (aClass fieldNamed: #var2).
		aClass defineIVarField: (aClass fieldNamed: #var3).
		aClass defineRegularField: (aClass fieldNamed: #var4).

		self assert: (aClass fieldNamed: #var1) isInstanceVariable.
		self assert: (aClass fieldNamed: #var2) isRegularField.
		self assert: (aClass fieldNamed: #var3) isInstanceVariable.
		self assert: (aClass fieldNamed: #var4) isRegularField.

		self assert: (instance var1 = 1).
		self assert: (instance var2 = 2).
		self assert: (instance var3 = 3).
		self assert: (instance var4 = 4).

		"Remember definition"
		defB := String streamContents:[:s| aClass fileOutOn: s].

		"Now recompile to defA in one fell swoop changing multiple fields at once"
		defA readStream fileInAnnouncing: 'Defining class...'.

		self assert: (aClass fieldNamed: #var1) isRegularField.
		self assert: (aClass fieldNamed: #var2) isInstanceVariable.
		self assert: (aClass fieldNamed: #var3) isRegularField.
		self assert: (aClass fieldNamed: #var4) isInstanceVariable.

		self assert: (instance var1 = 1).
		self assert: (instance var2 = 2).
		self assert: (instance var3 = 3).
		self assert: (instance var4 = 4).

		"And again for defB"
		defB readStream fileInAnnouncing: 'Defining class...'.

		self assert: (aClass fieldNamed: #var1) isInstanceVariable.
		self assert: (aClass fieldNamed: #var2) isRegularField.
		self assert: (aClass fieldNamed: #var3) isInstanceVariable.
		self assert: (aClass fieldNamed: #var4) isRegularField.

		self assert: (instance var1 = 1).
		self assert: (instance var2 = 2).
		self assert: (instance var3 = 3).
		self assert: (instance var4 = 4).

	] ensure:[
		aClass removeFromSystem.
		Utilities authorInitialsPerSe = 'test' ifTrue:[Utilities setAuthorInitials: ''].
	].
! !

!CSimplePlayerTests methodsFor: 'tests' stamp: 'ar 10/31/2004 15:15'!
testMultiFont
	player := CPlayer new.
	player text: 'This is some text'.
	player openAt: world center in: world.
	self waitTick.
	self fonts do:[:font|
		player textFont: font.
		self assert: (player textFont = font).
		self waitTick.
	].! !

!CSimplePlayerTests methodsFor: 'class reshape' stamp: 'ar 4/28/2005 19:54'!
testObjectToCObjectWithSubclasses
	"Test that reshaping an iVar to a field preserves the value"
	| aClass instance subclass |
	Utilities authorInitialsPerSe isEmptyOrNil ifTrue:[Utilities setAuthorInitials: 'test'].
	self deny: (Smalltalk includesKey: #CSimplePlayerTestsClassForTestFieldAndVar).
	self deny: (Smalltalk includesKey: #CSimplePlayerTestsClassForTestFieldAndVar2).
	aClass := Object subclass: #CSimplePlayerTestsClassForTestFieldAndVar
		instanceVariableNames: 'testValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	subclass := aClass subclass: #CSimplePlayerTestsClassForTestFieldAndVar2
		instanceVariableNames: 'testValue2'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.

	[
		instance := subclass new.
		instance instVarNamed: 'testValue' put: 1.
		instance instVarNamed: 'testValue2' put: 42.
		self assert: (instance instVarNamed: 'testValue') = 1.
		self assert: (instance instVarNamed: 'testValue2') = 42.

		aClass := CObject subclass: #CSimplePlayerTestsClassForTestFieldAndVar
			instanceVariableNames: 'testValue'
			classVariableNames: ''
			poolDictionaries: ''
			category: self class category.

		self assert: (aClass fieldNamed: #testValue) isInstanceVariable.
		self assert: (aClass instVarNames includes: 'testValue').
		self assert: (instance instVarNamed: 'testValue') = 1.

		self assert: (subclass fieldNamed: #testValue2) isInstanceVariable.
		self assert: (subclass instVarNames includes: 'testValue2').
		self assert: (instance instVarNamed: 'testValue2') = 42.

	] ensure:[
		aClass removeFromSystem.
		subclass removeFromSystem.
		Utilities authorInitialsPerSe = 'test' ifTrue:[Utilities setAuthorInitials: ''].
	].! !

!CSimplePlayerTests methodsFor: 'class reshape' stamp: 'ar 4/28/2005 19:54'!
testVarToField
	"Test that reshaping a field to an iVar preserves the value"
	| aClass instance |
	Utilities authorInitialsPerSe isEmptyOrNil ifTrue:[Utilities setAuthorInitials: 'test'].
	self deny: (Smalltalk includesKey: #CSimplePlayerTestsClassForTestFieldAndVar).
	aClass := CObject subclass: #CSimplePlayerTestsClassForTestFieldAndVar
		instanceVariableNames: 'testValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	[

		self assert: (aClass fieldNamed: #testValue) isRegularField.

		aClass defineIVarField: (aClass fieldNamed: #testValue).
		self deny: (aClass fieldNamed: #testValue) isRegularField.
		self assert: (aClass fieldNamed: #testValue) isInstanceVariable.
		self assert: (aClass instVarNames includes: 'testValue').

		instance := aClass new.
		instance testValue: 42.
		self assert: (instance testValue = 42).

		aClass defineRegularField: (aClass fieldNamed: #testValue).

		self assert: (aClass fieldNamed: #testValue) isRegularField.
		self deny: (aClass fieldNamed: #testValue) isInstanceVariable.
		self deny: (aClass instVarNames includes: 'testValue').
		self assert: (instance testValue = 42).

	] ensure:[
		aClass removeFromSystem.
		Utilities authorInitialsPerSe = 'test' ifTrue:[Utilities setAuthorInitials: ''].
	].
! !

!CSimplePlayerTests methodsFor: 'class reshape' stamp: 'ar 4/28/2005 19:54'!
testVarToFieldFromObject
	"Test that reshaping an iVar to a field preserves the value"
	| aClass instance |
	Utilities authorInitialsPerSe isEmptyOrNil ifTrue:[Utilities setAuthorInitials: 'test'].
	self deny: (Smalltalk includesKey: #CSimplePlayerTestsClassForTestFieldAndVar).
	aClass := Object subclass: #CSimplePlayerTestsClassForTestFieldAndVar
		instanceVariableNames: 'testValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
	[
		instance := aClass new.
		instance instVarNamed: 'testValue' put: 42.
		self assert: (instance instVarNamed: 'testValue') = 42.

		aClass := CObject subclass: #CSimplePlayerTestsClassForTestFieldAndVar
			instanceVariableNames: 'testValue'
			classVariableNames: ''
			poolDictionaries: ''
			category: self class category.

		self assert: (aClass fieldNamed: #testValue) isInstanceVariable.
		self assert: (aClass instVarNames includes: 'testValue').
		self assert: (instance instVarNamed: 'testValue') = 42.

	] ensure:[
		aClass removeFromSystem.
		Utilities authorInitialsPerSe = 'test' ifTrue:[Utilities setAuthorInitials: ''].
	].
! !

!CTestCase class methodsFor: 'accessing' stamp: 'ar 5/30/2005 16:02'!
addToSuite: suite fromMethods: testMethods
	^super addToSuite: suite fromMethods: testMethods asArray sort! !

!CTestCase class methodsFor: 'accessing' stamp: 'ar 5/30/2005 16:02'!
buildSuite
	| suite |
	suite := CTestSuite new.
	suite name: self name asString.
	(self withAllSubclasses asArray sort:[:c1 :c2| c1 name <= c2 name]) do: [:each | 
		each isAbstract ifFalse: [each addToSuiteFromSelectors: suite].
	].
	^suite! !

!CTestCase class methodsFor: 'accessing' stamp: 'ar 5/14/2005 16:23'!
isAbstract
	^self subclasses notEmpty! !

!CTestCase class methodsFor: 'accessing' stamp: 'ar 5/14/2005 16:17'!
testSelectors
	"Include selectors from superclasses"
	| set cls |
	set := Set new.
	cls := self.
	[cls == CTestCase] whileFalse:[
		set addAll: (cls sunitSelectors select: [:each | 'test*' sunitMatch: each]).
		cls := cls superclass.
	].
	^set asArray sort! !

!CTestCase methodsFor: 'running' stamp: 'ar 4/15/2007 22:33'!
debugAsFailure
	debugging := true.
	^super debugAsFailure! !

!CTestCase methodsFor: 'utils' stamp: 'ar 10/31/2004 15:09'!
fonts
	"Answer a set of fonts used for testing"
	^{StrikeFont familyName: #Atlanta size: 11 emphasized: 1.
	StrikeFont familyName: #NewYork size: 22 emphasized: 2}.! !

!CTestCase methodsFor: 'private' stamp: 'ar 3/14/2005 20:39'!
myScripts
	^myScripts ifNil:[#()]! !

!CTestCase methodsFor: 'private' stamp: 'ar 3/14/2005 20:39'!
myScripts: scriptList
	myScripts := scriptList.! !

!CTestCase methodsFor: 'running' stamp: 'ar 12/10/2009 02:09'!
runCase
	| window test label script |
	self ifTweak:[] ifNot:[
		"Make up a new world"
		parentProcess := Processor activeProcess.
		window := CProjectMorph open: CTestWorld.
		test := window model project island shallowCopy: self.
		script := test startScript: #runCaseAndDelete: withArguments:{window}.
		[script isDone] whileFalse:[World doOneCycleNow].
		^nil
	].
	world := Processor activeProject world.
	(world isKindOf: CTestWorld) ifFalse:[^self error: 'Not a test world'].
	world clipping: true.
	world removeAll.
	world add: (label := CLabel on: self class name,'>>', testSelector).
	label width: world width.
	label color: Color white.
	hand := Processor activeProject primaryHand.
	hand mouseFocus: nil; keyboardFocus: nil; cursorFocus: nil; balloonTarget: nil.
	self sendMouseMoveTo: 0@0.

	[self setUp.
	self waitTick.
	[self performTest] on: TestFailure, Error do:[:ex|
		debugging == true ifTrue:[ex pass].
		parentProcess ifNil:[ex pass] ifNotNil:[parentProcess signalException: ex].
	]] ensure: [
		self tearDown.
	].! !

!CTestCase methodsFor: 'running' stamp: 'ar 5/30/2005 15:44'!
runCaseAndDelete: window
	[self runCase] ensure:[
		WorldState addDeferredUIMessage:[window delete].
	].! !

!CTestCase methodsFor: 'running' stamp: 'ar 4/15/2007 22:36'!
runCaseAsFailure: aSemaphore
	debugging := true.
	[self runCase] ensure:[aSemaphore signal].
! !

!CTestCase methodsFor: 'utils' stamp: 'ar 5/30/2005 14:46'!
sendEvent: evt
	hand startScript: #dispatchEvent: withArguments:{evt}.
	self waitTick.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 10/28/2004 14:11'!
sendInputText: aString
	aString do:[:ch| self sendKeyStroke: ch].! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:09'!
sendKeyDown: ch
	| evt |
	evt := CKeyboardEvent new
		setType: #keyDown
		buttons: hand lastEvent buttons
		position: hand position
		keyValue: ch asInteger
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:09'!
sendKeyStroke: ch
	| evt |
	evt := CKeyboardEvent new
		setType: #keystroke
		buttons: hand lastEvent buttons
		position: hand position
		keyValue: ch asInteger
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:09'!
sendKeyUp: ch
	| evt |
	evt := CKeyboardEvent new
		setType: #keyUp
		buttons: hand lastEvent buttons
		position: hand position
		keyValue: ch asInteger
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:10'!
sendMouseDown
	| evt |
	evt := CMouseButtonEvent new
		setType: #mouseDown
		position: hand position
		which: 4 "red"
		buttons: 4 "red"
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:10'!
sendMouseDownTo: obj
	| evt |
	evt := CMouseButtonEvent new
		setType: #mouseDown
		position: (obj localToWorld: obj localBounds center)
		which: 4 "red"
		buttons: 4 "red"
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:11'!
sendMouseEnterTo: obj
	| evt |
	evt := CMouseMoveEvent new
		setType: #mouseMove
		startPoint: hand position
		endPoint: (obj localToWorld: obj localBounds center)
		trail: #()
		buttons: hand lastEvent buttons
		hand: hand
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:11'!
sendMouseLeaveTo: obj
	| evt |
	evt := CMouseMoveEvent new
		setType: #mouseMove
		startPoint: hand position
		endPoint: (obj localToWorld: 0@0) - 10
		trail: #()
		buttons: hand lastEvent buttons
		hand: hand
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:11'!
sendMouseMoveTo: obj
	| evt pt |
	pt := obj isPoint ifTrue:[obj] ifFalse:[obj localToWorld: obj localBounds center].
	evt := CMouseMoveEvent new
		setType: #mouseMove
		startPoint: hand position
		endPoint: pt
		trail: #()
		buttons: hand lastEvent buttons
		hand: hand
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:10'!
sendMouseUp
	| evt |
	evt := CMouseButtonEvent new
		setType: #mouseUp
		position: hand position
		which: 4 "red"
		buttons: 0 "red"
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 8/28/2005 20:10'!
sendMouseUpTo: obj
	| evt |
	evt := CMouseButtonEvent new
		setType: #mouseUp
		position: (obj localToWorld: obj localBounds center)
		which: 4 "red"
		buttons: 0 "red"
		hand: hand 
		stamp: Time millisecondClockValue.
	self sendEvent: evt.! !

!CTestCase methodsFor: 'setup' stamp: 'ar 5/30/2005 14:43'!
setUp
! !

!CTestCase methodsFor: 'utils' stamp: 'ar 10/27/2004 15:45'!
tearDown
	Display restore.! !

!CTestCase methodsFor: 'utils' stamp: 'ar 11/10/2004 18:21'!
waitTick
	"world runMorphicCycle."
	super waitTick.! !

CTestCase subclass: #CWidgetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CWidgetTest commentStamp: 'ar 10/27/2004 17:10' prior: 0!
Common superclass providing some generic utilities.!

CWidgetTest subclass: #CButtonCostumeTest
	instanceVariableNames: 'button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CButtonCostumeTest commentStamp: '<historical>' prior: 0!
Tests for button costumes.!

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 5/13/2005 14:06'!
newButton
	button := CButton new.
	button label: 'TestButton'.
	button costume: CButtonCostume new.
	^button! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:19'!
setUp
	button := self newButton.
	button openAt: world center in: world.
	self waitTick.! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 5/13/2005 14:09'!
testDefaultLabel
	self waitTick.
	self assert: button costume buttonLabel text asString = button label asString! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:31'!
testImage
	| ff |
	ff := Form extent: 367@214 depth: 4.
	button image: ff.
	self waitTick.
	self assert: button costume buttonImage graphicForm == ff.! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:29'!
testLabel
	button label: 'TestButton'.
	self waitTick.
	self assert: button costume buttonLabel text asString = 'TestButton'.! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:09'!
testLabelFont
	| font |
	font := self fonts first.
	button font: font.
	self waitTick.
	self assert: button costume buttonLabel textFont = font.! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:10'!
testMultiFont
	self fonts do:[:font|
		button font: font.
		self waitTick.
		self assert: button costume buttonLabel textFont = font.
	].
! !

!CButtonCostumeTest methodsFor: 'tests' stamp: 'ar 7/11/2005 11:12'!
testPlayerWithNilSelected
	"Test that the costume can deal with a player having nil selected state properly"
	self waitTick.
	button selected: false. "@@@ for lazy initialization"
	button selected: nil.
	self shouldnt:[button costume onSelectedChanged] raise: Error.
	self waitTick.
! !

CButtonCostumeTest subclass: #CCheckBoxCostumeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CCheckBoxCostumeTest commentStamp: '<historical>' prior: 0!
Tests for checkbox costume.!

!CCheckBoxCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:54'!
newButton
	button := CCheckBox new.
	button label: 'Check Box'.
	button costume: CCheckBoxCostume new.
	^button! !

!CCheckBoxCostumeTest methodsFor: 'tests' stamp: 'ar 3/29/2010 21:56'!
testCheckMark
	self deny: button value.
	self assert: button costume checkMark textColor = Color transparent.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self sendMouseUp.
	self assert: button value.
	self assert: button costume checkMark textColor = Color veryDarkGray.
! !

CButtonCostumeTest subclass: #CImageButtonCostumeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CImageButtonCostumeTest commentStamp: '<historical>' prior: 0!
Tests for image button costume.!

!CImageButtonCostumeTest methodsFor: 'tests' stamp: 'ar 5/13/2005 14:07'!
newButton
	button := CImageButton new.
	button label: 'ImageButton'.
	button costume: CButtonCostume new.
	^button! !

CButtonCostumeTest subclass: #CPushButtonCostumeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CPushButtonCostumeTest commentStamp: '<historical>' prior: 0!
Tests for push button costume.!

!CPushButtonCostumeTest methodsFor: 'tests' stamp: 'ar 5/13/2005 14:07'!
newButton
	button := CButton new.
	button label: 'PushButton'.
	button costume: CPushButtonCostume new.
	^button! !

!CPushButtonCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:59'!
testSelection
	self deny: (button selected).
	self deny: (button costume borderStyle == #inset).
	button select.
	self waitTick.
	self assert: (button costume borderStyle == #inset).
	button deselect.
	self waitTick.
	self deny: (button costume borderStyle == #inset).
! !

CButtonCostumeTest subclass: #CRadioButtonCostumeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CRadioButtonCostumeTest commentStamp: '<historical>' prior: 0!
Tests for radio button costume.!

!CRadioButtonCostumeTest methodsFor: 'tests' stamp: 'ar 5/13/2005 14:07'!
newButton
	button := CRadioButton new. 
	button label: 'RadioButton'.
	button costume: CRadioButtonCostume new.
	^button! !

!CRadioButtonCostumeTest methodsFor: 'tests' stamp: 'ar 3/29/2010 21:57'!
testSelection
	self deny: button selected.
	self assert: (button costume checkMark text asString = 'q').
	button select.
	self waitTick.
	self assert: (button costume checkMark text asString = 'o').
	button deselect.
	self waitTick.
	self assert: (button costume checkMark text asString = 'q').! !

CButtonCostumeTest subclass: #CTabButtonCostumeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CTabButtonCostumeTest commentStamp: '<historical>' prior: 0!
Tests for tab button costume.!

!CTabButtonCostumeTest methodsFor: 'tests' stamp: 'ar 5/13/2005 14:08'!
newButton
	button := CTabButton new. 
	button label: 'TabButton'.
	button costume: CTabButtonCostume new.
	^button! !

!CTabButtonCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 13:01'!
testSelection
	self deny: (button selected).
	self assert: (button costume fillStyle = #solid).
	button select.
	self waitTick.
	self assert: (button costume fillStyle = #verticalGradient).
	button deselect.
	self waitTick.
	self assert: (button costume fillStyle = #solid).
! !

CButtonCostumeTest subclass: #CWindowButtonCostumeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CWindowButtonCostumeTest commentStamp: '<historical>' prior: 0!
Tests for window button costume.!

!CWindowButtonCostumeTest methodsFor: 'utils' stamp: 'ar 12/19/2004 00:38'!
newButton
	button := CWindowButton new.
	button label: 'x'.
	button costume: CWindowButtonCostume new.
	^button! !

CWidgetTest subclass: #CButtonTest
	instanceVariableNames: 'button buttonA buttonB buttonC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CButtonTest commentStamp: 'ar 10/27/2004 17:08' prior: 0!
Tests essential button behavior, e.g., state changes.!

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/30/2004 12:40'!
newButton
	^CButton new! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 3/13/2005 21:14'!
selectButtonsABC
	buttonA select. self waitTick.
	self assert: (buttonA selected).
	self deny: (buttonB selected).
	self deny: (buttonC selected).
	buttonB select. self waitTick.
	self deny: (buttonA selected).
	self assert: (buttonB selected).
	self deny: (buttonC selected).
	buttonC select. self waitTick.
	self deny: (buttonA selected).
	self deny: (buttonB selected).
	self assert: (buttonC selected).
! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 11/10/2004 18:19'!
setUp
	button := self newButton.
	button label: 'TestButton'.
	button openAt: world center in: world.
	self waitTick.! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 3/13/2005 21:14'!
setupButtonsABC
	button close.
	buttonA := self newButton.
	buttonA label:'test1'.
	buttonB := self newButton.
	buttonB label:'test2'.
	buttonC := self newButton.
	buttonC label:'test3'.
	buttonA openAt: world center in: world.
	buttonB openAt: world center in: world.
	buttonC openAt: world center in: world.
	buttonB topLeft: buttonA topRight.
	buttonC topLeft: buttonB topRight.
	self waitTick.! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 12/19/2004 00:39'!
testAppropriateCostume
	self assert: (button costume isKindOf: button class basicNew defaultCostume).! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/28/2004 15:05'!
testButtonDisabled
	self assert:(button state == #normal).
	button disable.
	self assert:(button state == #disabled).

	self sendMouseEnterTo: button.
	self assert:(button state == #disabled).
	self sendMouseDownTo: button.
	self assert: (button state == #disabled).
	self sendMouseLeaveTo: button.
	self assert: (button state == #disabled).
	self sendMouseEnterTo: button.
	self assert: (button state == #disabled).
	self sendMouseUpTo: button.
	self assert: (button state == #disabled).
! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 15:23'!
testButtonDown
	self assert:(button state == #normal).
	self sendMouseEnterTo: button.
	self assert:(button state == #over).
	self sendMouseDownTo: button.
	self assert: (button state == #pressed).
	self sendMouseUpTo: button.
	self assert: (button state == #over).
	self sendMouseLeaveTo: button.
	self assert: (button state == #normal).
! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 15:43'!
testButtonDownLeaveEnterUp
	self assert:(button state == #normal).
	self sendMouseEnterTo: button.
	self assert:(button state == #over).
	self sendMouseDown.
	self assert: (button state == #pressed).
	self sendMouseLeaveTo: button.
	self assert: (button state == #normal).
	self sendMouseEnterTo: button.
	self assert: (button state == #pressed).
	self sendMouseUp.
	self assert: (button state == #over).! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 15:39'!
testButtonDownLeaveUp
	self assert:(button state == #normal).
	self sendMouseEnterTo: button.
	self assert:(button state == #over).
	self sendMouseDown.
	self assert: (button state == #pressed).
	self sendMouseLeaveTo: button.
	self assert: (button state == #normal).
	self sendMouseUp.
	self assert: (button state == #normal).! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 15:47'!
testButtonFire
	| fired |
	fired := false.
	self startScript:[fired := true] when:{button. #fire}.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self sendMouseUp.
	self assert: fired.
! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 15:48'!
testButtonFiresNotWhenDisabled
	| fired |
	fired := false.
	self startScript:[fired := true] when:{button. #fire}.
	button disable.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self sendMouseUp.
	self assert: fired not.
! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 15:46'!
testButtonLabel
	self assert: (button label = 'TestButton').! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 5/30/2005 16:10'!
testButtonOver
	self assert:(button state == #normal).
	self sendMouseEnterTo: button.
	self assert:(button state == #over).
	self sendMouseLeaveTo: button.
	self assert: (button state == #normal).
! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 10/27/2004 17:11'!
testButtonSelected
	button select.
	self assert: button selected.! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 5/13/2005 14:10'!
testDefaultLabel
	self waitTick.
	button label ifNotNil:[
		self assert: button costume buttonLabel text asString = button label asString
	].! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 3/13/2005 21:14'!
testGroupWithCollection
	| holder |
	self setupButtonsABC.
	holder := CCollection new.
	holder add: buttonA.
	holder add: buttonB.
	holder add: buttonC.
	buttonA group: holder.
	buttonB group: holder.
	buttonC group: holder.

	self selectButtonsABC.! !

!CButtonTest methodsFor: 'testing' stamp: 'ar 6/24/2005 21:03'!
testGroupWithHolder
	| holder offset |
	self setupButtonsABC.
	offset := buttonA topLeft.
	holder := CHolder new.
	holder color: Color white.
	holder topLeft: offset.
	holder extent: buttonC corner - offset.
	holder add: buttonA.
	holder add: buttonB.
	holder add: buttonC.
	world add: holder.
	buttonA moveBy: offset negated.
	buttonB moveBy: offset negated.
	buttonC moveBy: offset negated.
	buttonA group: holder.
	buttonB group: holder.
	buttonC group: holder.

	self selectButtonsABC.! !

CButtonTest subclass: #CCheckBoxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CCheckBoxTest commentStamp: 'ar 10/27/2004 17:09' prior: 0!
Tests the invariants of a check box, e.g., representing true and false.!

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:46'!
newButton
	^CCheckBox new! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 2/28/2005 14:16'!
testCheckBoxDeselected
	self deny: button selected.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self sendMouseUp.
	self assert: button selected.
	self sendMouseDown.
	self sendMouseUp.
	self deny: button selected.! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:46'!
testCheckBoxDisabled
	self deny: (button disabled).
	button disable.
	self assert: (button disabled).
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self deny: button value.
	self sendMouseUp.
	self deny: button value.! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 2/28/2005 14:15'!
testCheckBoxSelected
	self deny: button selected.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self sendMouseUp.
	self assert: button selected.
! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 2/28/2005 14:21'!
testCheckBoxSelectionFollowsValue
	button value: true.
	self waitTick.
	self assert: button selected.
	button value: false.
	self waitTick.
	self deny: button selected.

! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:46'!
testCheckBoxValueFalse
	button value: true.
	self assert: button value.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self assert: button value.
	self sendMouseUp.
	self deny: button value.! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:46'!
testCheckBoxValueToggle
	self deny: button value.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self deny: button value.
	self sendMouseUp.
	self assert: button value.
	self sendMouseDown.
	self assert: button value.
	self sendMouseUp.
	self deny: button value.
! !

!CCheckBoxTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:46'!
testCheckBoxValueTrue
	self deny: button value.
	self sendMouseEnterTo: button.
	self sendMouseDown.
	self deny: button value.
	self sendMouseUp.
	self assert: button value.! !

CButtonTest subclass: #CGroupButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CGroupButtonTest commentStamp: '<historical>' prior: 0!
Tests for group buttons (e.g., buttons which are in groups by default)!

!CGroupButtonTest methodsFor: 'tests' stamp: 'ar 3/13/2005 21:17'!
clickButtonsABC

	self sendMouseMoveTo: buttonA.
	self sendMouseDown.
	self sendMouseUp.
	self assert: (buttonA selected).
	self deny: (buttonB selected).
	self deny: (buttonC selected).
	self sendMouseMoveTo: buttonB.
	self sendMouseDown.
	self sendMouseUp.
	self deny: (buttonA selected).
	self assert: (buttonB selected).
	self deny: (buttonC selected).
	self sendMouseMoveTo: buttonC.
	self sendMouseDown.
	self sendMouseUp.
	self deny: (buttonA selected).
	self deny: (buttonB selected).
	self assert: (buttonC selected).
! !

!CGroupButtonTest methodsFor: 'tests' stamp: 'ar 3/13/2005 21:15'!
testCollectionGroup
	| holder |
	self setupButtonsABC.
	holder := CCollection new.
	holder add: buttonA.
	holder add: buttonB.
	holder add: buttonC.
	buttonA group: holder.
	buttonB group: holder.
	buttonC group: holder.

	self clickButtonsABC.! !

!CGroupButtonTest methodsFor: 'tests' stamp: 'ar 3/13/2005 21:17'!
testDefaultGroup
	self setupButtonsABC.
	self assert: (buttonA group == buttonB group).
	self assert: (buttonB group == buttonC group).
! !

!CGroupButtonTest methodsFor: 'tests' stamp: 'ar 6/24/2005 21:04'!
testHolderGroup
	| holder offset |
	self setupButtonsABC.
	offset := buttonA topLeft.
	holder := CHolder new.
	holder color: Color white.
	holder topLeft: offset.
	holder extent: buttonC corner - offset.
	holder add: buttonA.
	holder add: buttonB.
	holder add: buttonC.
	world add: holder.
	buttonA moveBy: offset negated.
	buttonB moveBy: offset negated.
	buttonC moveBy: offset negated.
	buttonA group: holder.
	buttonB group: holder.
	buttonC group: holder.

	self clickButtonsABC.! !

!CGroupButtonTest methodsFor: 'tests' stamp: 'ar 3/13/2005 21:17'!
testSelection

	self setupButtonsABC.
	self clickButtonsABC.
! !

CGroupButtonTest subclass: #CRadioButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CRadioButtonTest commentStamp: 'ar 10/27/2004 17:10' prior: 0!
Tests essential behavior of radio buttons, e.g., group selection.!

!CRadioButtonTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:43'!
newButton
	^CRadioButton new! !

CGroupButtonTest subclass: #CTabButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CTabButtonTest commentStamp: '<historical>' prior: 0!
Tests for tab buttons.!

!CTabButtonTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:45'!
newButton
	^CTabButton new! !

CButtonTest subclass: #CImageButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CImageButtonTest commentStamp: 'ar 10/27/2004 17:10' prior: 0!
Tests essential behavior of image buttons, e.g., showing the appropriate button in the appropriate state.!

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:41'!
newButton
	| ff |
	button := CImageButton new.
	button normalImage: (ff := Form extent: 32@32 depth: 16).
	ff fillColor: Color blue.
	button overImage: (ff := Form extent: 32@32 depth: 16).
	ff fillColor: Color yellow.
	button pressedImage: (ff := Form extent: 32@32 depth: 16).
	ff fillColor: Color green.
	button disabledImage: (ff := Form extent: 32@32 depth: 16).
	ff fillColor: Color gray.
	button selectedImage: (ff := Form extent: 32@32 depth: 16).
	ff fillColor: Color red.
	^button! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/27/2004 17:42'!
testButtonDisabled
	self assert:(button image == button normalImage).
	button disable.
	self waitTick.
	self assert:(button image == button disabledImage).

	self sendMouseEnterTo: button.
	self assert:(button image == button disabledImage).
	self sendMouseDownTo: button.
	self assert: (button image == button disabledImage).
	self sendMouseLeaveTo: button.
	self assert: (button image == button disabledImage).
	self sendMouseEnterTo: button.
	self assert: (button image == button disabledImage).
	self sendMouseUpTo: button.
	self assert: (button image == button disabledImage).
! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/27/2004 17:21'!
testButtonDown
	self assert:(button image == button normalImage).
	self sendMouseEnterTo: button.
	self assert:(button image == button overImage).
	self sendMouseDownTo: button.
	self assert: (button image == button pressedImage).
	self sendMouseUpTo: button.
	self assert: (button image == button overImage).
	self sendMouseLeaveTo: button.
	self assert: (button image == button normalImage).
! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/27/2004 17:21'!
testButtonDownLeaveEnterUp
	self assert:(button image == button normalImage).
	self sendMouseEnterTo: button.
	self assert:(button image == button overImage).
	self sendMouseDown.
	self assert: (button image == button pressedImage).
	self sendMouseLeaveTo: button.
	self assert: (button image == button normalImage).
	self sendMouseEnterTo: button.
	self assert: (button image == button pressedImage).
	self sendMouseUp.
	self assert: (button image == button overImage).! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/27/2004 17:21'!
testButtonDownLeaveUp
	self assert:(button image == button normalImage).
	self sendMouseEnterTo: button.
	self assert:(button image == button overImage).
	self sendMouseDown.
	self assert: (button image == button pressedImage).
	self sendMouseLeaveTo: button.
	self assert: (button image == button normalImage).
	self sendMouseUp.
	self assert: (button image == button normalImage).! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/27/2004 16:08'!
testButtonOver
	self assert:(button image == button normalImage).
	self sendMouseEnterTo: button.
	self assert:(button image == button overImage).
	self sendMouseLeaveTo: button.
	self assert: (button image == button normalImage).
! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:31'!
testImage
	| ff |
	ff := Form extent: 367@214 depth: 4.
	button image: ff.
	self waitTick.
	self assert: button costume buttonImage graphicForm == ff.! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:29'!
testLabel
	button label: 'TestButton'.
	self waitTick.
	self assert: button costume buttonLabel text asString = 'TestButton'.! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:10'!
testLabelFont
	| font |
	font := self fonts first.
	button font: font.
	self waitTick.
	self assert: button costume buttonLabel textFont = font.! !

!CImageButtonTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:11'!
testMultiFont
	self fonts do:[:font|
		button font: font.
		self waitTick.
		self assert: button costume buttonLabel textFont = font.
	].! !

CButtonTest subclass: #CPushButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CPushButtonTest commentStamp: '<historical>' prior: 0!
Tests for push button.!

!CPushButtonTest methodsFor: 'tests' stamp: 'ar 10/30/2004 12:55'!
newButton
	^CPushButton new! !

CButtonTest subclass: #CWindowButtonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CWindowButtonTest commentStamp: '<historical>' prior: 0!
Tests for window button.!

!CWindowButtonTest methodsFor: 'utils' stamp: 'ar 12/19/2004 00:37'!
newButton
	button := CWindowButton new.
	button label: 'x'.
	^button! !

CWidgetTest subclass: #CCommonListTests
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CCommonListTests commentStamp: '<historical>' prior: 0!
Tests that all lists should adhere to.!

!CCommonListTests methodsFor: 'setup' stamp: 'ar 4/23/2005 16:16'!
newList
	"Create a new list and give it the costume to test"! !

!CCommonListTests methodsFor: 'setup' stamp: 'ar 5/14/2005 16:06'!
setUp
	list := self newList.
	list addAll:{1. 2. 3}.
	list extent: 200@200.
	list openAt: world center in: world.
	self waitTick.! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testAllowDeselect

	self sendMouseEnterTo: list.
	self sendMouseMoveTo: list globalBounds topCenter + (0@7).

	list allowDeselect: true.
	self sendMouseDown.
	self assert: list cursor = 1.
	self sendMouseDown.
	self assert: list cursor = 0.
	self sendMouseDown.
	self assert: list cursor = 1.

	list allowDeselect: false.
	self sendMouseDown.
	self assert: list cursor = 1.
	self sendMouseDown.
	self assert: list cursor = 1.

! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testArrowKeys
	self sendMouseEnterTo: list.
	self sendMouseMoveTo: list globalBounds topCenter + (0@7).
	self sendMouseDown.
	self assert: list cursor = 1.
	self sendKeyDown: (Character value: 31).
	self assert: list cursor = 2.
	self sendKeyDown: (Character value: 31).
	self assert: list cursor = 3.
	self sendKeyDown: (Character value: 30).
	self assert: list cursor = 2.
	self sendKeyDown: (Character value: 30).
	self assert: list cursor = 1.
! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testChangeItems
	| count newItems |
	self waitTick.
	count := list costume playerItems size.
	newItems := CCollection new.
	newItems addAll: (1 to: count+2).
	list items: newItems.
	self waitTick.
	self assert: list costume playerItems size = (count+2).
	list removeLast; removeLast.
	self waitTick.
	self assert: list costume playerItems size = count.! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testHScrollable
	self deny: list hScrollable.
	self deny: list costume hScrollBar visible.

	list hScrollable: true.
	self waitTick.
	self assert: list hScrollable.
	self assert: list costume hScrollBar visible.

	list hScrollable: false.
	self waitTick.
	self deny: list hScrollable.
	self deny: list costume hScrollBar visible.
! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testSelectMouse
	self sendMouseEnterTo: list.
	self sendMouseMoveTo: list globalBounds topCenter + (0@7).
	self sendMouseDown.
	self assert: list cursor = 1.! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testSelection
	list wrapCursor: true.

	list cursor: 1.
	self assert: (list cursor = 1).
	self assert: (list selection == (list at: list cursor)).

	list selection: (list at: 2).
	self assert: (list cursor = 2).
	self assert: (list selection == (list at: list cursor)).

	list next.
	self assert: (list cursor = 3).
	self assert: (list selection == (list at: list cursor)).

	list next.
	self assert: (list cursor = 1).
	self assert: (list selection == (list at: list cursor)).
! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testVScrollable
	self assert: list vScrollable.
	self assert: list costume vScrollBar visible.

	list vScrollable: false.
	self waitTick.
	self deny: list vScrollable.
	self deny: list costume vScrollBar visible.

	list vScrollable: true.
	self waitTick.
	self assert: list vScrollable.
	self assert: list costume vScrollBar visible.

! !

!CCommonListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:15'!
testViewBehavior
	| count |
	self waitTick.
	count := list costume playerItems size.
	list add: 'Hello'; add: 'World'.
	self waitTick.
	self assert: list costume playerItems size = (count+2).
	list removeLast; removeLast.
	self waitTick.
	self assert: list costume playerItems size = count.
! !

CCommonListTests subclass: #CListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CListTests commentStamp: '<historical>' prior: 0!
Tests for generic lists/costumes.!

!CListTests methodsFor: 'setup' stamp: 'ar 4/23/2005 16:18'!
newList
	^CList new.! !

!CListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:18'!
testAppropriateCostume
	self assert: (list costume isKindOf: CListCostume).! !

CCommonListTests subclass: #CMulitColumnListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CMulitColumnListTests methodsFor: 'setup' stamp: 'ar 4/23/2005 16:23'!
drawName: item in: itemBox on: aCanvas font: font color: aColor
	| itemHeight boxOrigin |
	itemHeight := itemBox height.
	boxOrigin := itemBox origin.
	boxOrigin := boxOrigin + (itemHeight + 2 @ 0).
	aCanvas drawString: 'Test: ', item asString in: (boxOrigin corner: itemBox corner) font: font color: aColor.! !

!CMulitColumnListTests methodsFor: 'setup' stamp: 'ar 4/23/2005 16:23'!
drawValue: item in: itemBox on: aCanvas font: font color: aColor
	| itemHeight boxOrigin |
	itemHeight := itemBox height.
	boxOrigin := itemBox origin.
	boxOrigin := boxOrigin + (itemHeight + 2 @ 0).
	aCanvas drawString: item asString in: (boxOrigin corner: itemBox corner) font: font color: aColor.! !

!CMulitColumnListTests methodsFor: 'setup' stamp: 'ar 4/23/2005 16:22'!
newList
	list := CMultiColumnList new.
	list addColumn: 'Name' for: self
		width: 50 color: CWidgetLibrary default noColor
		action: nil draw: #drawName:in:on:font:color:.
	list addColumn: 'Value' for: self
		width: 50 color: CWidgetLibrary default paneColor
		action: nil draw: #drawValue:in:on:font:color:.
	^list! !

CCommonListTests subclass: #CStringListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CStringListTests commentStamp: '<historical>' prior: 0!
Tests for CStringList.!

!CStringListTests methodsFor: 'setup' stamp: 'ar 4/23/2005 16:17'!
newList
	^CStringList new.! !

!CStringListTests methodsFor: 'tests' stamp: 'ar 4/23/2005 16:17'!
testAppropriateCostume
	self assert: (list costume isKindOf: CStringListCostume).! !

CWidgetTest subclass: #CDropDownListTests
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CDropDownListTests commentStamp: '<historical>' prior: 0!
Tests for drop-down list.!

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 4/15/2007 22:40'!
setUp
	list := CDropDownList new.
	list value: 'foobar'.
	list addAll:{123. 456. 789}.
	list allowEditing: true.
	list width: 100.
	list openAt: world center in: world.
	self waitTick.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 4/22/2005 18:45'!
testAccept
	self sendMouseEnterTo: list.
	self sendMouseDown.
	self sendInputText: 'Hello'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self waitTick.
	self assert: list value = 'Hello'.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 4/15/2007 22:42'!
testAcceptAfterSelect
	list selection: 123.
	self waitTick.
	self assert: list value = 123.

	self sendMouseEnterTo: list.
	self sendMouseDown.
	self sendInputText: 'Hello'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self waitTick.
	self assert: list value = 'Hello'.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 1/23/2005 03:01'!
testAppropriateCostume
	self assert: (list costume isKindOf: list class basicNew defaultCostume).! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 12/19/2004 21:09'!
testAutoAccept
	list converter: CNumberConverter new.
	list autoAccept: true.
	list value: 42.
	self waitTick.
	self assert: list value = 42.
	self assert: list text asString = '42'.
	self sendMouseEnterTo: list.
	self sendMouseDown.
	self sendInputText: '123'.
	self sendMouseLeaveTo: list.
	self sendMouseDown.
	hand keyboardFocus: nil.
	self waitTick.
	self assert: list value = 123.
	self assert: list text asString = '123'.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 12/19/2004 20:57'!
testAutoGrowShrinkWrap
	"Make sure growing works as requested"
	list hResizing: #shrinkWrap.
	list clipping: false.
	self sendMouseEnterTo: list.
	self sendMouseDown.
	self assert: list scrollOffset isZero.
	self sendInputText: 'This is a pretty long string to see if growing works'.
	self assert: list scrollOffset isZero.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: list scrollOffset isZero.
! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 12/19/2004 20:57'!
testAutoGrowSpaceFill
	"Make sure growing works as requested"
	list hResizing: #spaceFill.
	list clipping: false.
	self sendMouseEnterTo: list.
	self sendMouseDown.
	self assert: list scrollOffset isZero.
	self sendInputText: 'This is a pretty long string to see if growing works'.
	self assert: list scrollOffset isZero.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: list scrollOffset isZero.
! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 12/19/2004 21:11'!
testAutoRevert
	list converter: CNumberConverter new.
	list autoRevert: true.
	list value: 42.
	self waitTick.
	self assert: list value = 42.
	self assert: list text asString = '42'.
	self sendMouseEnterTo: list.
	self sendMouseDown.
	self sendInputText: '123'.
	self sendMouseLeaveTo: list.
	self sendMouseDown.
	hand keyboardFocus: nil.
	self waitTick.
	self assert: list value = 42.
	self assert: list text asString = '42'.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 12/19/2004 21:08'!
testFailedAccept
	list converter: CNumberConverter new.
	list value: 42.
	self waitTick.
	self assert: list value = 42.
	self assert: list text asString = '42'.

	self sendMouseEnterTo: list.
	self sendMouseDown.
	self sendInputText: 'mumble'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: list value = 42.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 5/30/2005 16:49'!
testNumericAccept
	list converter: CNumberConverter new.
	self sendMouseEnterTo: list.
	self sendMouseDown.
	self sendMouseUp.
	self sendInputText: '42'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: list value = 42.! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 4/22/2005 17:59'!
testProperInitialSize
	| listA listB |
	listA := CDropDownList new.
	listA value: 'Hello world!!'.
	listA open.

	listB := CDropDownList new.
	listB open.
	listB value: 'Hello world!!'.

	self waitTick.
	self assert: (listA bounds = listB bounds).! !

!CDropDownListTests methodsFor: 'tests' stamp: 'ar 4/15/2007 22:41'!
testValueNotInList
	list selection: 123.
	self waitTick.
	self assert: list value = 123.

	list value: 'Hello'.
	self waitTick.
	self assert: list value = 'Hello'.! !

CWidgetTest subclass: #CInputFieldTest
	instanceVariableNames: 'inputField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CInputFieldTest commentStamp: '<historical>' prior: 0!
Tests for (single line) input field.!

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:19'!
setUp
	inputField := CInputField new.
	inputField width: 100.
	inputField openAt: world center in: world.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:15'!
testAccept
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField editor hasKeyboardFocus.
	self sendInputText: 'Hello'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField value = 'Hello'.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 1/23/2005 03:02'!
testAppropriateCostume
	self assert: (inputField costume isKindOf: inputField class basicNew defaultCostume).! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 12/19/2004 20:03'!
testAutoAccept
	inputField converter: CNumberConverter new.
	inputField autoAccept: true.
	inputField value: 42.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField editor hasKeyboardFocus.
	self sendInputText: '123'.
	self sendMouseLeaveTo: inputField.
	self sendMouseDown.
	hand keyboardFocus: nil.
	self waitTick.
	self assert: inputField value = 123.
	self assert: inputField contents asString = '123'.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 12/19/2004 20:06'!
testAutoGrowShrinkWrap
	"Make sure growing works as requested"
	inputField hResizing: #shrinkWrap.
	inputField clipping: false.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField scrollOffset isZero.
	self sendInputText: 'This is a pretty long string to see if growing works'.
	self assert: inputField scrollOffset isZero.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField scrollOffset isZero.
! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 12/19/2004 20:05'!
testAutoGrowSpaceFill
	"Make sure growing works as requested"
	inputField hResizing: #spaceFill.
	inputField clipping: false.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField scrollOffset isZero.
	self sendInputText: 'This is a pretty long string to see if growing works'.
	self assert: inputField scrollOffset isZero.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField scrollOffset isZero.
! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 12/19/2004 20:04'!
testAutoRevert
	inputField converter: CNumberConverter new.
	inputField autoRevert: true.
	inputField value: 42.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField editor hasKeyboardFocus.
	self sendInputText: '123'.
	self sendMouseLeaveTo: inputField.
	self sendMouseDown.
	hand keyboardFocus: nil.
	self waitTick.
	self assert: inputField value = 42.
	self assert: inputField contents asString = '42'.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:17'!
testFailedAccept
	inputField converter: CNumberConverter new.
	inputField value: 42.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField editor hasKeyboardFocus.
	self sendInputText: 'mumble'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField value = 42.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:09'!
testKeyboardFocus
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField editor hasKeyboardFocus.
! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:15'!
testNumericAccept
	inputField converter: CNumberConverter new.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField editor hasKeyboardFocus.
	self sendInputText: '42'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField value = 42.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 12/19/2004 20:06'!
testScrollingRigid
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField scrollOffset isZero.
	self sendInputText: 'This is a pretty long string to see if scrolling works'.
	self deny: inputField scrollOffset isZero.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField scrollOffset isZero.
! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 12/19/2004 20:06'!
testScrollingSpaceFill
	inputField hResizing: #spaceFill.
	inputField clipping: true.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self assert: inputField scrollOffset isZero.
	self sendInputText: 'This is a pretty long string to see if scrolling works'.
	self deny: inputField scrollOffset isZero.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: inputField scrollOffset isZero.
! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:42'!
testTextCopy
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self sendInputText: 'This some text'.
	inputField selectFrom: 6 to: 10.
	inputField copySelection.
	self assert: CClipboard clipboardText asString = 'some'.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:43'!
testTextCut
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self sendInputText: 'This some text'.
	inputField selectFrom: 6 to: 10.
	inputField cutSelection.
	self assert: CClipboard clipboardText asString = 'some'.
	self assert: inputField contents = 'This  text'.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:43'!
testTextPaste
	CClipboard clipboardText: 'some'.
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self sendInputText: 'This  text'.
	inputField selectFrom: 6 to: 6.
	inputField pasteSelection.
	inputField contents = 'This is some text'.! !

!CInputFieldTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:41'!
testTextSelection
	self sendMouseEnterTo: inputField.
	self sendMouseDown.
	self sendInputText: 'This some text'.
	inputField selectFrom: 6 to: 10.
	self waitTick.
	self assert: (inputField selection = 'some').! !

CWidgetTest subclass: #CLabelCostumeTest
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CLabelCostumeTest commentStamp: '<historical>' prior: 0!
Tests for label costume.!

!CLabelCostumeTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:19'!
setUp
	label := CLabel new.
	label costume: CLabelCostume new.
	label openAt: world center in: world.! !

!CLabelCostumeTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:10'!
testLabelFont
	| font |
	font := self fonts first.
	label font: font.
	self waitTick.
	self assert: label costume textFont = font.! !

!CLabelCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 00:19'!
testLabelObject
	label value: 42.
	self waitTick.
	self assert: label costume text asString = '42'.! !

!CLabelCostumeTest methodsFor: 'tests' stamp: 'ar 10/30/2004 00:19'!
testLabelText
	label value: 'Hello World'.
	self waitTick.
	self assert: label costume text asString = 'Hello World'.! !

!CLabelCostumeTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:11'!
testMultiFont
	self fonts do:[:font|
		label font: font.
		self waitTick.
		self assert: label costume textFont = font.
	].! !

CWidgetTest subclass: #CLabelTest
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CLabelTest commentStamp: '<historical>' prior: 0!
Tests for label.!

!CLabelTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:19'!
setUp
	label := CLabel new.
	label openAt: world center in: world.! !

!CLabelTest methodsFor: 'tests' stamp: 'ar 1/23/2005 03:02'!
testAppropriateCostume
	self assert: (label costume isKindOf: label class basicNew defaultCostume).! !

!CLabelTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:28'!
testLabelObject
	label value: 42.
	self waitTick.
	self assert: label text asString = '42'.! !

!CLabelTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:27'!
testLabelText
	label value: 'Hello World'.
	self waitTick.
	self assert: label text asString = 'Hello World'.! !

CWidgetTest subclass: #CMenuTest
	instanceVariableNames: 'menu selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CMenuTest commentStamp: '<historical>' prior: 0!
Tests for menus.!

!CMenuTest methodsFor: 'utils' stamp: 'ar 10/31/2004 13:27'!
selectItem1
	selected := #item1.
! !

!CMenuTest methodsFor: 'utils' stamp: 'ar 10/31/2004 13:27'!
selectItem2
	selected := #item2.! !

!CMenuTest methodsFor: 'utils' stamp: 'ar 10/31/2004 13:27'!
selectItem3
	selected := #item3.! !

!CMenuTest methodsFor: 'tests' stamp: 'ar 1/23/2005 03:04'!
testAppropriateCostume
	menu := CMenu new.
	self assert: (menu costume isKindOf: menu class basicNew defaultCostume).! !

!CMenuTest methodsFor: 'tests' stamp: 'ar 10/31/2004 13:29'!
testNonStickyClick
	menu := CMenu new.
	menu add: 'TestItem1' target: self action: #selectItem1.
	menu add: 'TestItem2' target: self action: #selectItem2.
	menu add: 'TestItem3' target: self action: #selectItem3.
	menu add: 'TestItem4' target: self action: #selectItem4.
	menu label: 'TestMenu'.
	menu openAt: world center in: world.
	self waitTick.
	self sendMouseEnterTo: menu.
	self sendMouseDown.
	self sendMouseUp.
	self deny: menu asPrimCostume isInWorld.
	self assert: selected == #item2.! !

!CMenuTest methodsFor: 'tests' stamp: 'ar 10/31/2004 13:29'!
testNonStickyClickOutside
	menu := CMenu new.
	menu add: 'TestItem1' target: self action: #selectItem1.
	menu add: 'TestItem2' target: self action: #selectItem2.
	menu add: 'TestItem3' target: self action: #selectItem3.
	menu add: 'TestItem4' target: self action: #selectItem4.
	menu label: 'TestMenu'.
	menu openAt: world center in: world.
	self waitTick.
	self sendMouseLeaveTo: menu.
	self sendMouseDown.
	self sendMouseUp.
	self deny: menu asPrimCostume isInWorld.
	self assert: selected == nil.! !

!CMenuTest methodsFor: 'tests' stamp: 'ar 10/31/2004 13:49'!
testStickyClick
	menu := CMenu new.
	menu sticky: true.
	menu add: 'TestItem1' target: self action: #selectItem1.
	menu add: 'TestItem2' target: self action: #selectItem2.
	menu add: 'TestItem3' target: self action: #selectItem3.
	menu add: 'TestItem4' target: self action: #selectItem4.
	menu label: 'TestMenu'.
	menu openAt: world center in: world.
	self waitTick.
	self sendMouseEnterTo: menu.
	self sendMouseDown.
	self sendMouseUp.
	self assert: menu asPrimCostume isInWorld.
	self assert: selected == #item2.! !

!CMenuTest methodsFor: 'tests' stamp: 'ar 10/31/2004 13:30'!
testStickyClickOutside
	menu := CMenu new.
	menu sticky: true.
	menu add: 'TestItem1' target: self action: #selectItem1.
	menu add: 'TestItem2' target: self action: #selectItem2.
	menu add: 'TestItem3' target: self action: #selectItem3.
	menu add: 'TestItem4' target: self action: #selectItem4.
	menu label: 'TestMenu'.
	menu openAt: world center in: world.
	self waitTick.
	self sendMouseLeaveTo: menu.
	self sendMouseDown.
	self sendMouseUp.
	self assert: menu asPrimCostume isInWorld.
	self assert: selected == nil.! !

CWidgetTest subclass: #CProgressBarCostumeTest
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CProgressBarCostumeTest commentStamp: '<historical>' prior: 0!
Tests for progress bar costume.!

!CProgressBarCostumeTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:19'!
setUp
	bar := CProgressBar new.
	bar costume: CProgressBarCostume new.
	bar openAt: world center in: world.! !

!CProgressBarCostumeTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:09'!
testFont
	| font |
	font := self fonts first.
	bar font: font.
	self waitTick.
	self assert: bar costume progressLabel textFont = font.! !

!CProgressBarCostumeTest methodsFor: 'tests' stamp: 'ar 5/30/2005 15:24'!
testLabel
	| label |
	bar label: 'TestLabel'.
	self waitTick.
	label := bar costume progressLabel text.
	self assert: label = 'TestLabel'.! !

!CProgressBarCostumeTest methodsFor: 'tests' stamp: 'ar 10/31/2004 15:12'!
testMultiFont
	self fonts do:[:font|
		bar font: font.
		self waitTick.
		self assert: bar costume progressLabel textFont = font.
	].! !

CWidgetTest subclass: #CProgressBarTest
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CProgressBarTest commentStamp: '<historical>' prior: 0!
Tests for progress bar.!

!CProgressBarTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:19'!
setUp
	bar := CProgressBar new.
	bar openAt: world center in: world.! !

!CProgressBarTest methodsFor: 'tests' stamp: 'ar 4/24/2005 18:51'!
testAbort
	| script |
	script := self startScript:[
		bar displayProgress: 'progress' at: world center from: 0 to: 1 during:[
			(Delay forSeconds: 100) wait.
		].
	].
	self waitTick.
	self deny: script isTerminated.
	bar abort.
	self assert: script isTerminated.
! !

!CProgressBarTest methodsFor: 'tests' stamp: 'ar 1/23/2005 03:02'!
testAppropriateCostume
	self assert: (bar costume isKindOf: bar class basicNew defaultCostume).! !

!CProgressBarTest methodsFor: 'tests' stamp: 'ar 10/30/2004 00:09'!
testGetFraction
	bar value: 0.
	self waitTick.
	self assert: bar fraction = 0.0.
	bar value: bar max.
	self waitTick.
	self assert: bar fraction = 1.0.
! !

!CProgressBarTest methodsFor: 'tests' stamp: 'ar 10/30/2004 00:10'!
testLabel
	bar label: 'Progress'.
	self waitTick.
	self assert: bar label = 'Progress'.! !

!CProgressBarTest methodsFor: 'tests' stamp: 'ar 10/30/2004 00:09'!
testSetFraction
	bar value: bar max.
	self waitTick.
	bar fraction: 0.0.
	self waitTick.
	self assert: bar value = bar min.
	bar fraction: 1.0.
	self waitTick.
	self assert: bar value = bar max.! !

CWidgetTest subclass: #CTextConverterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CTextConverterTests commentStamp: '<historical>' prior: 0!
Tests for text converters.!

!CTextConverterTests methodsFor: 'tests' stamp: 'ar 10/28/2004 14:40'!
testDateConverter
	| converter date printed read |
	converter := CDateConverter new.
	self should: [converter readValueFrom: 'mumble'] raise: Error.
	date := Date today.
	self shouldnt:[printed := converter printValue: date] raise: Error.
	self shouldnt:[read := converter readValue: printed] raise: Error.
	self assert: read = date.
! !

!CTextConverterTests methodsFor: 'tests' stamp: 'ar 10/28/2004 14:42'!
testFloatConverter
	| converter printed read number |
	converter := CNumberConverter new.
	self should: [converter readValueFrom: 'mumble'] raise: Error.
	number := 42.0.
	self shouldnt:[printed := converter printValue: number] raise: Error.
	self shouldnt:[read := converter readValue: printed] raise: Error.
	self assert: read = number.
! !

!CTextConverterTests methodsFor: 'tests' stamp: 'ar 10/28/2004 14:42'!
testIntConverter
	| converter printed read number |
	converter := CNumberConverter new.
	self should: [converter readValueFrom: 'mumble'] raise: Error.
	number := 42.
	self shouldnt:[printed := converter printValue: number] raise: Error.
	self shouldnt:[read := converter readValue: printed] raise: Error.
	self assert: read = number.
! !

!CTextConverterTests methodsFor: 'tests' stamp: 'ar 10/28/2004 14:42'!
testStringConverter
	| converter printed read text |
	converter := CTextConverter new.
	text := 'mumble' asText allBold.
	self shouldnt:[printed := converter printValue: text] raise: Error.
	self shouldnt:[read := converter readValue: printed] raise: Error.
	self assert: read = 'mumble'.
! !

!CTextConverterTests methodsFor: 'tests' stamp: 'ar 10/28/2004 14:41'!
testTextConverter
	| converter printed read text |
	converter := CTextConverter new.
	text := 'mumble' asText allBold.
	self shouldnt:[printed := converter printValue: text] raise: Error.
	self shouldnt:[read := converter readValue: printed] raise: Error.
	self assert: read = text.
! !

CWidgetTest subclass: #CTextEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CTextEditorTest commentStamp: '<historical>' prior: 0!
Tests for text editor.!

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 11/10/2004 18:20'!
setUp
	editor := CInputField new.
	editor width: 100.
	editor openAt: world center in: world.! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 1/23/2005 03:03'!
testAppropriateCostume
	self assert: (editor costume isKindOf: editor class basicNew defaultCostume).! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:31'!
testInput
	self sendMouseEnterTo: editor.
	self sendMouseDown.
	self assert: editor editor hasKeyboardFocus.
	self sendInputText: 'Hello'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self assert: editor contents = 'Hello'.! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 10/28/2004 14:33'!
testInputDisabled
	editor allowEditing: false.
	self waitTick.
	self sendMouseEnterTo: editor.
	self sendMouseDown.
	self deny: editor editor hasKeyboardFocus.
	self sendInputText: 'Hello'.
	self sendKeyDown: 13.
	self sendKeyUp: 13.
	self deny: editor contents asString = 'Hello'.! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:45'!
testTextCopy
	self sendMouseEnterTo: editor.
	self sendMouseDown.
	self sendInputText: 'This some text'.
	editor selectFrom: 6 to: 10.
	editor copySelection.
	self assert: CClipboard clipboardText asString = 'some'.! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:46'!
testTextCut
	self sendMouseEnterTo: editor.
	self sendMouseDown.
	self sendInputText: 'This some text'.
	editor selectFrom: 6 to: 10.
	editor cutSelection.
	self assert: CClipboard clipboardText asString = 'some'.
	self assert: editor contents = 'This  text'.! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:46'!
testTextPaste
	CClipboard clipboardText: 'some'.
	self sendMouseEnterTo: editor.
	self sendMouseDown.
	self sendInputText: 'This  text'.
	editor selectFrom: 6 to: 6.
	editor pasteSelection.
	editor contents = 'This is some text'.! !

!CTextEditorTest methodsFor: 'tests' stamp: 'ar 10/28/2004 17:46'!
testTextSelection
	self sendMouseEnterTo: editor.
	self sendMouseDown.
	self sendInputText: 'This some text'.
	editor selectFrom: 6 to: 10.
	self waitTick.
	self assert: (editor selection = 'some').! !

CWidgetTest subclass: #CWidgetCostumeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CWidgetCostumeTests commentStamp: '<historical>' prior: 0!
Tests for costumes. Created via:

CWidgetCostume withAllSubclassesDo:[:costumeClass|
	CWidgetCostumeTests compile: 
('testCOSTUMENew
	"Ensure we can createa COSTUME"
	self shouldnt:[Smalltalk at: #COSTUME ifPresent:[:cls| cls new]] raise: Error.
' copyReplaceAll:'COSTUME' with: costumeClass name) 
classified: 'tests-widgets'].!

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCButtonCostumeNew
	"Ensure we can createa CButtonCostume"
	self shouldnt:[Smalltalk at: #CButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCCheckBoxCostumeNew
	"Ensure we can createa CCheckBoxCostume"
	self shouldnt:[Smalltalk at: #CCheckBoxCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCCustomDrawListCostumeNew
	"Ensure we can createa CCustomDrawListCostume"
	self shouldnt:[Smalltalk at: #CCustomDrawListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCDropDownListCostumeNew
	"Ensure we can createa CDropDownListCostume"
	self shouldnt:[Smalltalk at: #CDropDownListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCInputFieldCostumeNew
	"Ensure we can createa CInputFieldCostume"
	self shouldnt:[Smalltalk at: #CInputFieldCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCLabelCostumeNew
	"Ensure we can createa CLabelCostume"
	self shouldnt:[Smalltalk at: #CLabelCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCListCostumeNew
	"Ensure we can createa CListCostume"
	self shouldnt:[Smalltalk at: #CListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCListLikeCostumeNew
	"Ensure we can createa CListLikeCostume"
	self shouldnt:[Smalltalk at: #CListLikeCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 8/27/2005 19:34'!
testCMenuBarCostume2New
	"Ensure we can createa CMenuBarCostume"
	self shouldnt:[Smalltalk at: #CMenuBarCostume2 ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 8/27/2005 19:35'!
testCMenuCostume2New
	"Ensure we can createa CMenuCostume"
	self shouldnt:[Smalltalk at: #CMenuCostume2 ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCMultiColumnListCostumeNew
	"Ensure we can createa CMultiColumnListCostume"
	self shouldnt:[Smalltalk at: #CMultiColumnListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCProgressBarCostumeNew
	"Ensure we can createa CProgressBarCostume"
	self shouldnt:[Smalltalk at: #CProgressBarCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCPushButtonCostumeNew
	"Ensure we can createa CPushButtonCostume"
	self shouldnt:[Smalltalk at: #CPushButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCRadioButtonCostumeNew
	"Ensure we can createa CRadioButtonCostume"
	self shouldnt:[Smalltalk at: #CRadioButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCScrollBarCostumeNew
	"Ensure we can createa CScrollBarCostume"
	self shouldnt:[Smalltalk at: #CScrollBarCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCScrollButtonCostumeNew
	"Ensure we can createa CScrollButtonCostume"
	self shouldnt:[Smalltalk at: #CScrollButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCScrollPaneCostumeNew
	"Ensure we can createa CScrollPaneCostume"
	self shouldnt:[Smalltalk at: #CScrollPaneCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCScrollableCostumeNew
	"Ensure we can createa CScrollableCostume"
	self shouldnt:[Smalltalk at: #CScrollableCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCScrollableTextEditorCostumeNew
	"Ensure we can createa CScrollableTextEditorCostume"
	self shouldnt:[Smalltalk at: #CScrollableTextEditorCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCSliderCostumeNew
	"Ensure we can createa CSliderCostume"
	self shouldnt:[Smalltalk at: #CSliderCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCSpinnerButtonsCostumeNew
	"Ensure we can createa CSpinnerButtonsCostume"
	self shouldnt:[Smalltalk at: #CSpinnerButtonsCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCSpinnerCostumeNew
	"Ensure we can createa CSpinnerCostume"
	self shouldnt:[Smalltalk at: #CSpinnerCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCSpinnerListCostumeNew
	"Ensure we can createa CSpinnerListCostume"
	self shouldnt:[Smalltalk at: #CSpinnerListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCStringListCostumeNew
	"Ensure we can createa CStringListCostume"
	self shouldnt:[Smalltalk at: #CStringListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCTabButtonCostumeNew
	"Ensure we can createa CTabButtonCostume"
	self shouldnt:[Smalltalk at: #CTabButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCTabButtonListCostumeNew
	"Ensure we can createa CTabButtonListCostume"
	self shouldnt:[Smalltalk at: #CTabButtonListCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCTextEditorCostumeNew
	"Ensure we can createa CTextEditorCostume"
	self shouldnt:[Smalltalk at: #CTextEditorCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCTileButtonCostumeNew
	"Ensure we can createa CTileButtonCostume"
	self shouldnt:[Smalltalk at: #CTileButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCToolBarButtonCostumeNew
	"Ensure we can createa CToolBarButtonCostume"
	self shouldnt:[Smalltalk at: #CToolBarButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCTreeWidgetCostumeNew
	"Ensure we can createa CTreeWidgetCostume"
	self shouldnt:[Smalltalk at: #CTreeWidgetCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCWheelWidgetCostumeNew
	"Ensure we can createa CWheelWidgetCostume"
	self shouldnt:[Smalltalk at: #CWheelWidgetCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCWidgetCostumeNew
	"Ensure we can createa CWidgetCostume"
	self shouldnt:[Smalltalk at: #CWidgetCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCWindowButtonCostumeNew
	"Ensure we can createa CWindowButtonCostume"
	self shouldnt:[Smalltalk at: #CWindowButtonCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetCostumeTests methodsFor: 'tests-widgets' stamp: 'ar 5/6/2005 14:15'!
testCWindowCostumeNew
	"Ensure we can createa CWindowCostume"
	self shouldnt:[Smalltalk at: #CWindowCostume ifPresent:[:cls| cls new]] raise: Error.
! !

!CWidgetTest methodsFor: 'tests copying' stamp: 'ar 6/18/2005 14:16'!
testCopyBetweenIslands
	"Copy the widget from one island to another"
	| islandA islandB copy writer |
	self widget ifNil:[^self].

	islandA := Processor activeIsland.

	"Create new island"
	islandB := CProjectIsland newProject: CPlayer.

	"Copy the widget"
	copy := islandB copy: self widget.
	islandB at: #copy put: copy.

	"Checkpoint islandB to see that copying worked correctly"
	writer := CProjectWriter new.
	writer snapshot: islandB.
	writer imports do:[:each| 
		each isFarRef ifTrue:[self deny: each island == islandA].
	].! !

!CWidgetTest methodsFor: 'tests copying' stamp: 'ar 6/2/2005 12:34'!
widget
	^nil! !

CWidgetTest subclass: #CWindowFrameTests
	instanceVariableNames: 'window costume frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-CoreTests-Widgets'!

!CWindowFrameTests commentStamp: '<historical>' prior: 0!
Tests for window frame.!

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:10'!
setUp
	window := CWindow new.
	window openAt: world center in: world.
	costume := window costume.
	frame := costume windowFrame.! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 1/23/2005 03:03'!
testAppropriateCostume
	self assert: (costume isKindOf: window class basicNew defaultCostume).! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:01'!
testCloseBox
	window closeBox: true.
	self waitTick.
	self assert: (frame closeButton visible).
	window closeBox: false.
	self waitTick.
	self deny: (frame closeButton visible).
	window closeBox: true.
	self waitTick.
	self assert: (frame closeButton visible).
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:16'!
testCloseRequest
	| success |
	window closeBox: true.
	success := false.
	self startScript:[success := true] when:{window. #closeRequest}.
	self sendMouseEnterTo: frame closeButton.
	self sendMouseDownTo: frame closeButton.
	self sendMouseUpTo: frame closeButton.
	self assert: success.
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:16'!
testCollapseRequest
	| success |
	window minimizeBox: true.
	success := false.
	self startScript:[success := true] when:{window. #collapseRequest}.
	self sendMouseEnterTo: frame collapseButton.
	self sendMouseDownTo: frame collapseButton.
	self sendMouseUpTo: frame collapseButton.
	self assert: success.
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 1/22/2005 22:40'!
testExpandRequest
	| success |
	window maximizeBox: true.
	success := false.
	self startScript:[success := true] when:{window. #expandRequest}.
	self sendMouseEnterTo: frame expandButton.
	self sendMouseDownTo: frame expandButton.
	self sendMouseUpTo: frame expandButton.
	self assert: success.
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:10'!
testLabel
	self deny: window label = 'Test window label'.
	window label: 'Test window label'.
	self waitTick.
	self assert: frame windowLabel value asString = 'Test window label'.! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:01'!
testMaximizeBox
	window maximizeBox: true.
	self waitTick.
	self assert: (frame expandButton visible).
	window maximizeBox: false.
	self waitTick.
	self deny: (frame expandButton visible).
	window maximizeBox: true.
	self waitTick.
	self assert: (frame expandButton visible).
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:02'!
testMinimizeBox
	window minimizeBox: true.
	self waitTick.
	self assert: (frame collapseButton visible).
	window minimizeBox: false.
	self waitTick.
	self deny: (frame collapseButton visible).
	window minimizeBox: true.
	self waitTick.
	self assert: (frame collapseButton visible).
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:13'!
testWindowFrameChange
	self deny: window label = 'Test window label'.
	window closeBox: window closeBox not.
	window minimizeBox: window minimizeBox not.
	window maximizeBox: window maximizeBox not.
	window label: 'Test window label'.
	costume windowFrame destroy.
	costume windowFrame: (frame := CWindowCostumeFrame new).
	self waitTick.
	self assert: window closeBox = frame closeButton visible.
	self assert: window minimizeBox = frame collapseButton visible.
	self assert: window maximizeBox = frame expandButton visible.
	self assert: window label = frame windowLabel value asString.
! !

!CWindowFrameTests methodsFor: 'tests' stamp: 'ar 12/20/2004 14:13'!
testWindowFrameChangeTextured
	self deny: window label = 'Test window label'.
	window closeBox: window closeBox not.
	window minimizeBox: window minimizeBox not.
	window maximizeBox: window maximizeBox not.
	window label: 'Test window label'.
	costume windowFrame destroy.
	costume windowFrame: (frame := CTexturedWindowFrame new).
	self waitTick.
	self assert: window closeBox = frame closeButton visible.
	self assert: window minimizeBox = frame collapseButton visible.
	self assert: window maximizeBox = frame expandButton visible.
	self assert: window label = frame windowLabel value asString.
! !
